/*
 *	6502(RP2A03/HuC6280) CPU G~[VEvO
 *
 *	"All Star Cast" All right Reserved
 *	(C) 2019  Fukuda, Kouji
 */

/*
 *	CPU 
 */

#define	MOS6502		0x01
#define	W65C02		0x02
#define	RP2A03		0x04
#define	HuC6280		0x08


/*
 *	CPU tO
 */

#define	PCUPDT		0x80	/* PC XVʒm */
#define	MEMOUT		0x02	/* o */
#define	VDCOUT		0x04	/* VDC o */


/*
 *	HALT tO
 */

#define	CPU_HALT	1
#define	CPU_RUNNING	0


/*
 *	tOEWX^̃rbg
 */
#define	FLAG_N		0x80	/* lKeBuEtO ʂ1 */
#define	FLAG_V		0x40	/* I[ot[EtO  */
#define	FLAG_T		0x20
#define	FLAG_Brk	0x10	/* uCNER}h */
#define	FLAG_D		0x08	/* fV}E[h */
#define	FLAG_I		0x04	/* 荞݋֎~tO */
#define	FLAG_Z		0x02	/* [EtO */
#define	FLAG_C		0x01	/* L[EtO */


/*
 *	vOEWX^EZbg
 */
typedef struct t_regs {
	unsigned char	A;
	unsigned char	Y;
	unsigned char	X;
	unsigned char	P;
} T_REGS;

/*
 *	VXeEWX^EZbg
 */

typedef struct t_pc_reg {
#if defined (BIG_ENDIAN)
	unsigned char	PCH;
	unsigned char	PCL;
#else
	unsigned char	PCL;
	unsigned char	PCH;
#endif
} t_PC_reg;

typedef struct t_pc_st {
	union pc {
		t_PC_reg	t_pc;
		unsigned short	pc;
	} pc;
} t_PC_st;

typedef struct t_sregs {
	t_PC_st		PC;	/* Program Counter */
	unsigned char	S;	/* Stack Pointer */
} T_SREGS;


/*
 *	oX
 */

/* Rg[EoX */

typedef struct t_ctl_bus {
	unsigned short	RDY:1;
	unsigned short	CK1:1;
	unsigned short	IRQ:1;
	unsigned short	NMI:1;
	unsigned short	SYNC:1;
	unsigned short	R_W:1;
	unsigned short	CK0:1;
	unsigned short	S0:1;
	unsigned short	CK2:1;
	unsigned short	RES:1;
	unsigned short	RFU:6;
} t_CTL_bus;

typedef struct t_pin_ctl {
	union ctl {
		t_CTL_bus	t_ctl;
		unsigned short	ctl;
	} ctl;
} T_PIN_CTL;


/* AhXEoX */

typedef struct t_addr_bus {
	unsigned short	AB15:1;
	unsigned short	AB14:1;
	unsigned short	AB13:1;
	unsigned short	AB12:1;
	unsigned short	AB11:1;
	unsigned short	AB10:1;
	unsigned short	AB9:1;
	unsigned short	AB8:1;
	unsigned short	AB7:1;
	unsigned short	AB6:1;
	unsigned short	AB5:1;
	unsigned short	AB4:1;
	unsigned short	AB3:1;
	unsigned short	AB2:1;
	unsigned short	AB1:1;
	unsigned short	AB0:1;
} t_ADDR_bus;

typedef struct t_pin_addr {
	union addr {
		t_ADDR_bus	t_addr;
		unsigned short	addr_bus;
	} addr;
} T_PIN_ADDR;


/* f[^EoX */

typedef struct t_data_bus {
	unsigned short	DB7:1;
	unsigned short	DB6:1;
	unsigned short	DB5:1;
	unsigned short	DB4:1;
	unsigned short	DB3:1;
	unsigned short	DB2:1;
	unsigned short	DB1:1;
	unsigned short	DB0:1;
} t_DATA_bus;

typedef struct t_pin_data {
	union data {
		t_DATA_bus	t_data;
		unsigned short	data_bus;
	} data;
} T_PIN_DATA;

typedef struct t_pin {
	T_PIN_CTL	t_ctl;
	T_PIN_DATA	t_data;
	T_PIN_ADDR	t_addr;
} T_PIN;
