/*
 *	6502(RP2A03/HuC6280) CPU G~[VEvO
 *
 *	"All Star Cast" All right Reserved
 *	(C) 2019  Fukuda, Kouji
 */

#include "../inc/cpu.h"

double		Real_CPU_Freq;
double		Emulate_CPU_Freq;

static unsigned char	IM;

static unsigned char	halt = CPU_RUNNING;

/*
 *	ubN]R[EobN֐
 *
 *	void callback_bt_6502(unsigned short, unsigned short, unsigned char)
 *
 *	1 Funsigned short		fBXeBl[VEAhX
 *	2 Funsigend short		\[XEAhX
 *	3 Funsigend char		]f[^
 *
 *	F
 *	ubN]sꂽۂɌĂяoR[EobN֐
 */
void
callback_bt_6502(unsigned short dst, unsigned short src, unsigned char data)
{
}

/*
 *	RtBO֐
 *
 *	void config_6502(double, double)
 *
 *	1 Fdouble			CPU g
 *	2 Fdouble			G~[gCPU g
 *	߂lFȂ
 *
 *	F
 *	TCNEXe[g̒̂߂ɁACPU g
 *	G~[gCPU gݒ肷
 */
void
config_6502(double Real_Freq, double Emu_Freq)
{
	Real_CPU_Freq = Real_Freq;
	Emulate_CPU_Freq = Emu_Freq;
}

/*
 *	TCNEXe[g֐
 *
 *	void clk_adj_6502(unsigned int)
 *
 *	1 Funsigned int		NbN
 *	߂lFȂ
 *
 *	F
 *	TCNEXe[g̒
 */
void
clk_adj_6502(unsigned int cycle)
{
	int i, j;

	if ((cycle != 0) && (Emulate_CPU_Freq != 0)) {
		j = (int)(((Real_CPU_Freq / Emulate_CPU_Freq) + 0.5) * cycle);
		for (i = 0; i < j; i++) {
			/*
			 *	NbN
			 */
			;
		}
	}
}

/*
 *	CPU Zbg֐
 *
 *	void rst_6502(T_PIN *, T_REGS *, T_SREGS *, unsigned char *)
 *
 *	1 F̈
 *	1 FT_PIN *cpu_pin		oX
 *	2 FT_REGS reg		vOEWX^
 *	3 FT_SREGS sysreg		VXeEWX^
 *	4 F荞݊ʒm/PC XVʒm
 *	߂lFȂ
 *
 *	F
 *	CPU ̃Zbg()
 */
void
rst_6502(unsigned char *mem, T_PIN *cpu_pin, T_REGS *reg, T_SREGS *sysreg, unsigned char *cpuflag)
{
	reg->P |= FLAG_I;
	reg->P &= (unsigned char)~FLAG_Brk;

	sysreg->PC.pc.t_pc.PCL = mem[0xfffc];
	sysreg->PC.pc.t_pc.PCH = mem[0xfffd];

	cpu_pin->t_ctl.ctl.ctl = 0;
	cpu_pin->t_data.data.data_bus = 0;
	cpu_pin->t_addr.addr.addr_bus = 0;

	*cpuflag |= PCUPDT;

	halt = CPU_RUNNING;

	return;
}


/*
 *	ߎs֐
 *
 *	int exe_6502(unsigned char *, T_PIN *, T_REGS *, T_REGS *, T_SREGS *, unsigned char *, unsigned char *, unsigned char *, unsigned char *, unsigned char)
 *
 *	1 F̈
 *	2 FT_PIN *cpu_pin		oX
 *	3 FT_REGS reg		vOEWX^
 *	4 FT_SREGS sysreg		VXeEWX^
 *	5 F荞݊ʒm/PC XVʒm
 *	6 FMPR WX^
 *	7 FVDC
 *	8 FCPU 
 *	߂lFHALT 
 *
 *	F
 *	CPU 
 *	clk ̓͂ɑB
 *	܂A荞ݓAoXωɂĂяo
 */
int
exe_6502(unsigned char *mem, T_PIN *cpu_pin, T_REGS *reg, T_SREGS *sysreg, unsigned char *cpuflag, unsigned char *mpr, unsigned char *vdc, unsigned char cpukind)
{
	char		temp_acr;
	unsigned char	temp_reg1, temp_reg2;
	unsigned short	temp_reg;
	unsigned short	ex_addressing;
	unsigned char	cnt;
	unsigned short	src, dst;
	unsigned int	len;

	/* 荞݊ʒm/PC XVʒmNA */
	*cpuflag = 0;

	if (halt == CPU_HALT) {
		return (int)halt;
	}

	/* ߃tFb` */
	cpu_pin->t_data.data.data_bus = mem[sysreg->PC.pc.pc];

	/* tFb`AhXAhXEoXɊi[ */
	cpu_pin->t_addr.addr.addr_bus = sysreg->PC.pc.pc;

	/* ߃fR[h */
	switch (cpu_pin->t_data.data.data_bus) {
		/* ADC	#imm */
		case 0x69:
			temp_reg = (unsigned short)(reg->A) + (unsigned short)mem[cpu_pin->t_addr.addr.addr_bus = ++sysreg->PC.pc.pc] + (unsigned short)(reg->P & FLAG_C);

			/* tOEIy[V */
			if (temp_reg > 0x00ff) {
				reg->P |= (FLAG_C);
			}
			else {
				reg->P &= ~FLAG_C;
			}
			temp_acr = (char)(temp_reg & 0x00ff);
			if (temp_acr < 0x00) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0x00) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}
			if (((temp_acr & 0x80) ^ (reg->A & 0x80)) && (!((reg->A & 0x80) == 0x10))) {
				reg->P |= FLAG_V;
			}
			else if ((!((temp_acr & 0x80) ^ (reg->A & 0x80))) && ((reg->A & 0x80) == 0x80)) {
				reg->P |= FLAG_V;
			}
			else {
				reg->P &= (unsigned char)~FLAG_V;
			}

			/* Zʊi[ */
			reg->A = (unsigned char)temp_acr;

			clk_adj_6502(2);
			break;
		/* ADC	imm (Zero Page) */
		case 0x65:
			temp_reg = (unsigned short)(reg->A) + (unsigned short)mem[mem[cpu_pin->t_addr.addr.addr_bus = ++sysreg->PC.pc.pc]] + (unsigned short)(reg->P & FLAG_C);

			/* tOEIy[V */
			if (temp_reg > 0x00ff) {
				reg->P |= (FLAG_C);
			}
			else {
				reg->P &= ~FLAG_C;
			}
			temp_acr = (char)(temp_reg & 0x00ff);
			if (temp_acr < 0x00) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0x00) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}
			if (((temp_acr & 0x80) ^ (reg->A & 0x80)) && (!((reg->A & 0x80) == 0x10))) {
				reg->P |= FLAG_V;
			}
			else if ((!((temp_acr & 0x80) ^ (reg->A & 0x80))) && ((reg->A & 0x80) == 0x80)) {
				reg->P |= FLAG_V;
			}
			else {
				reg->P &= (unsigned char)~FLAG_V;
			}

			/* Zʊi[ */
			reg->A = (unsigned char)temp_acr;

			clk_adj_6502(3);
			break;
		/* ADC	imm, X (Zero Page, X) */
		case 0x75:
			temp_reg1 = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X);
			temp_reg = (unsigned short)(reg->A) + (unsigned short)mem[cpu_pin->t_addr.addr.addr_bus = temp_reg1] + (unsigned short)(reg->P & FLAG_C);

			/* tOEIy[V */
			if (temp_reg > 0x00ff) {
				reg->P |= (FLAG_C);
			}
			else {
				reg->P &= ~FLAG_C;
			}
			temp_acr = (char)(temp_reg & 0x00ff);
			if (temp_acr < 0x00) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0x00) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}
			if (((temp_acr & 0x80) ^ (reg->A & 0x80)) && (!((reg->A & 0x80) == 0x10))) {
				reg->P |= FLAG_V;
			}
			else if ((!((temp_acr & 0x80) ^ (reg->A & 0x80))) && ((reg->A & 0x80) == 0x80)) {
				reg->P |= FLAG_V;
			}
			else {
				reg->P &= (unsigned char)~FLAG_V;
			}

			/* Zʊi[ */
			reg->A = (unsigned char)temp_acr;

			clk_adj_6502(4);
			break;
		/* ADC	nn' (Absolute) */
		case 0x6d:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			temp_reg = (unsigned short)(reg->A) + (unsigned short)mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] + (unsigned short)(reg->P & FLAG_C);

			/* tOEIy[V */
			if (temp_reg > 0x00ff) {
				reg->P |= (FLAG_C);
			}
			else {
				reg->P &= ~FLAG_C;
			}
			temp_acr = (char)(temp_reg & 0x00ff);
			if (temp_acr < 0x00) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0x00) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}
			if (((temp_acr & 0x80) ^ (reg->A & 0x80)) && (!((reg->A & 0x80) == 0x10))) {
				reg->P |= FLAG_V;
			}
			else if ((!((temp_acr & 0x80) ^ (reg->A & 0x80))) && ((reg->A & 0x80) == 0x80)) {
				reg->P |= FLAG_V;
			}
			else {
				reg->P &= (unsigned char)~FLAG_V;
			}

			/* Zʊi[ */
			reg->A = (unsigned char)temp_acr;

			clk_adj_6502(4);
			break;
		/* ADC	nn', X (Absolute, X) */
		case 0x7d:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			ex_addressing += reg->X;
			temp_reg = (unsigned short)(reg->A) + (unsigned short)mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] + (unsigned short)(reg->P & FLAG_C);

			/* tOEIy[V */
			if (temp_reg > 0x00ff) {
				reg->P |= (FLAG_C);
			}
			else {
				reg->P &= ~FLAG_C;
			}
			temp_acr = (char)(temp_reg & 0x00ff);
			if (temp_acr < 0x00) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0x00) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}
			if (((temp_acr & 0x80) ^ (reg->A & 0x80)) && (!((reg->A & 0x80) == 0x10))) {
				reg->P |= FLAG_V;
			}
			else if ((!((temp_acr & 0x80) ^ (reg->A & 0x80))) && ((reg->A & 0x80) == 0x80)) {
				reg->P |= FLAG_V;
			}
			else {
				reg->P &= (unsigned char)~FLAG_V;
			}

			/* Zʊi[ */
			reg->A = (unsigned char)temp_acr;

			clk_adj_6502(4);
			break;
		/* ADC	nn', Y (Absolute, Y) */
		case 0x79:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			ex_addressing += reg->Y;
			temp_reg = (unsigned short)(reg->A) + (unsigned short)mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] + (unsigned short)(reg->P & FLAG_C);

			/* tOEIy[V */
			if (temp_reg > 0x00ff) {
				reg->P |= (FLAG_C);
			}
			else {
				reg->P &= ~FLAG_C;
			}
			temp_acr = (char)(temp_reg & 0x00ff);
			if (temp_acr < 0x00) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0x00) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}
			if (((temp_acr & 0x80) ^ (reg->A & 0x80)) && (!((reg->A & 0x80) == 0x10))) {
				reg->P |= FLAG_V;
			}
			else if ((!((temp_acr & 0x80) ^ (reg->A & 0x80))) && ((reg->A & 0x80) == 0x80)) {
				reg->P |= FLAG_V;
			}
			else {
				reg->P &= (unsigned char)~FLAG_V;
			}

			/* Zʊi[ */
			reg->A = (unsigned char)temp_acr;

			clk_adj_6502(4);
			break;
		/* ADC	(imm, X) (Index Indirect) */
		case 0x61:
			ex_addressing = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X);
			temp_reg = (unsigned short)(reg->A) + (unsigned short)mem[cpu_pin->t_addr.addr.addr_bus = mem[ex_addressing]] + (unsigned short)(reg->P & FLAG_C);

			/* tOEIy[V */
			if (temp_reg > 0x00ff) {
				reg->P |= (FLAG_C);
			}
			else {
				reg->P &= ~FLAG_C;
			}
			temp_acr = (char)(temp_reg & 0x00ff);
			if (temp_acr < 0x00) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0x00) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}
			if (((temp_acr & 0x80) ^ (reg->A & 0x80)) && (!((reg->A & 0x80) == 0x10))) {
				reg->P |= FLAG_V;
			}
			else if ((!((temp_acr & 0x80) ^ (reg->A & 0x80))) && ((reg->A & 0x80) == 0x80)) {
				reg->P |= FLAG_V;
			}
			else {
				reg->P &= (unsigned char)~FLAG_V;
			}

			/* Zʊi[ */
			reg->A = (unsigned char)temp_acr;

			clk_adj_6502(6);
			break;
		/* ADC	(imm), Y (Indirect Index) */
		case 0x71:
			ex_addressing = (unsigned char)mem[++sysreg->PC.pc.pc];
			temp_reg = (unsigned short)(reg->A) + (unsigned short)mem[cpu_pin->t_addr.addr.addr_bus = (mem[ex_addressing] + reg->Y)] + (unsigned short)(reg->P & FLAG_C);

			/* tOEIy[V */
			if (temp_reg > 0x00ff) {
				reg->P |= (FLAG_C);
			}
			else {
				reg->P &= ~FLAG_C;
			}
			temp_acr = (char)(temp_reg & 0x00ff);
			if (temp_acr < 0x00) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0x00) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}
			if (((temp_acr & 0x80) ^ (reg->A & 0x80)) && (!((reg->A & 0x80) == 0x10))) {
				reg->P |= FLAG_V;
			}
			else if ((!((temp_acr & 0x80) ^ (reg->A & 0x80))) && ((reg->A & 0x80) == 0x80)) {
				reg->P |= FLAG_V;
			}
			else {
				reg->P &= (unsigned char)~FLAG_V;
			}

			/* Zʊi[ */
			reg->A = (unsigned char)temp_acr;

			clk_adj_6502(5);
			break;
		/* AND	#imm */
		case 0x29:
			temp_reg1 = reg->A & mem[cpu_pin->t_addr.addr.addr_bus = ++sysreg->PC.pc.pc];

			if ((char)temp_reg1 < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			reg->A = temp_reg1;

			clk_adj_6502(2);
			break;
		/* AND	imm (Zero Page) */
		case 0x25:
			temp_reg1 = reg->A & mem[mem[cpu_pin->t_addr.addr.addr_bus = ++sysreg->PC.pc.pc]];

			if ((char)temp_reg1 < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			reg->A = temp_reg1;

			clk_adj_6502(3);
			break;
		/* AND	imm, X (Zero Page, X) */
		case 0x35:
			temp_reg1 = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X);
			temp_reg1 = reg->A & mem[cpu_pin->t_addr.addr.addr_bus = temp_reg1];

			if ((char)temp_reg1 < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			reg->A = temp_reg1;

			clk_adj_6502(4);
			break;
		/* AND	nn' (Absolute) */
		case 0x2d:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			temp_reg1 = reg->A & mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing];

			if ((char)temp_reg1 < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			reg->A = temp_reg1;

			clk_adj_6502(4);
			break;
		/* AND	nn', X (Absolute, X) */
		case 0x3d:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			ex_addressing += reg->X;
			temp_reg1 = reg->A & mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing];

			if ((char)temp_reg1 < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			reg->A = temp_reg1;

			clk_adj_6502(4);
			break;
		/* AND	nn', Y (Absolute, Y) */
		case 0x39:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			ex_addressing += reg->Y;
			temp_reg1 = reg->A & mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing];

			if ((char)temp_reg1 < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			reg->A = temp_reg1;

			clk_adj_6502(4);
			break;
		/* AND	(imm, X) (Index Indirect) */
		case 0x21:
			ex_addressing = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X);
			temp_reg1 = reg->A & mem[cpu_pin->t_addr.addr.addr_bus = mem[ex_addressing]];

			if ((char)temp_reg1 < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			reg->A = temp_reg1;

			clk_adj_6502(6);
			break;
		/* AND	(imm), Y (Indirect Index) */
		case 0x31:
			ex_addressing = (unsigned char)mem[++sysreg->PC.pc.pc];
			temp_reg1 = reg->A & mem[cpu_pin->t_addr.addr.addr_bus = (mem[ex_addressing] + reg->Y)];

			if ((char)temp_reg1 < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			reg->A = temp_reg1;

			clk_adj_6502(5);
			break;
		/* ASL	A */
		case 0x0a:
			temp_reg = (unsigned short)(reg->A << 1);

			if (temp_reg & 0x0100) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)(~FLAG_C);
			}

			/* tOEIy[V */
			if (temp_reg == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}
			if ((char)(temp_reg & 0x00ff) < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}

			/* Zʊi[ */
			reg->A = cpu_pin->t_data.data.data_bus = (unsigned char)(temp_reg & 0x00ff);

			clk_adj_6502(2);
			break;
		/* ASL	imm (Zero Page) */
		case 0x06:
			temp_reg = (unsigned short)(mem[mem[cpu_pin->t_addr.addr.addr_bus = ++sysreg->PC.pc.pc]] << 1);

			if (temp_reg & 0x0100) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)(~FLAG_C);
			}

			/* tOEIy[V */
			if (temp_reg == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}
			if ((char)(temp_reg & 0x00ff) < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}

			/* Zʊi[ */
			mem[sysreg->PC.pc.pc] = cpu_pin->t_data.data.data_bus = (unsigned char)(temp_reg & 0x00ff);
			*cpuflag |= MEMOUT;

			clk_adj_6502(5);
			break;
		/* ASL	imm, X (Zero Page, X) */
		case 0x16:
			temp_reg = (unsigned short)(mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X)] << 1);

			if (temp_reg & 0x0100) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)(~FLAG_C);
			}

			/* tOEIy[V */
			if (temp_reg == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}
			if ((char)(temp_reg & 0x00ff) < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}

			/* Zʊi[ */
			mem[mem[sysreg->PC.pc.pc] + reg->X] = cpu_pin->t_data.data.data_bus = (unsigned char)(temp_reg & 0x00ff);
			*cpuflag |= MEMOUT;

			clk_adj_6502(6);
			break;
		/* ASL	nn' (Absolute) */
		case 0x0e:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			temp_reg = (unsigned short)(mem[cpu_pin->t_addr.addr.addr_bus = mem[ex_addressing]] << 1);

			if (temp_reg & 0x0100) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)(~FLAG_C);
			}

			/* tOEIy[V */
			if (temp_reg == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}
			if ((char)(temp_reg & 0x00ff) < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}

			/* Zʊi[ */
			mem[cpu_pin->t_addr.addr.addr_bus] = cpu_pin->t_data.data.data_bus = (unsigned char)(temp_reg & 0x00ff);
			*cpuflag |= MEMOUT;

			clk_adj_6502(6);
			break;
		/* ASL	nn', X (Absolute, X) */
		case 0x1e:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			ex_addressing += reg->X;
			temp_reg = (unsigned short)mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] << 1;

			if (temp_reg & 0x0100) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)(~FLAG_C);
			}

			/* tOEIy[V */
			if (temp_reg == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}
			if ((char)(temp_reg & 0x00ff) < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}

			/* Zʊi[ */
			mem[ex_addressing] = cpu_pin->t_data.data.data_bus = (unsigned char)(temp_reg & 0x00ff);
			*cpuflag |= MEMOUT;

			clk_adj_6502(7);
			break;
		/* BCC	#imm */
		case 0x90:
			if (!(reg->P & FLAG_C)) {
				sysreg->PC.pc.pc = (unsigned short)((sysreg->PC.pc.pc + 2) + (char)(mem[++sysreg->PC.pc.pc]));
				*cpuflag |= PCUPDT;
			}

			clk_adj_6502(2);
			break;
		/* BCS	#imm */
		case 0xb0:
			if (reg->P & FLAG_C) {
				sysreg->PC.pc.pc = (unsigned short)((sysreg->PC.pc.pc + 2) + (char)(mem[++sysreg->PC.pc.pc]));
				*cpuflag |= PCUPDT;
			}

			clk_adj_6502(2);
			break;
		/* BEQ	#imm */
		case 0xf0:
			if (reg->P & FLAG_Z) {
				sysreg->PC.pc.pc = (unsigned short)((sysreg->PC.pc.pc + 2) + (char)(mem[++sysreg->PC.pc.pc]));
				*cpuflag |= PCUPDT;
			}

			clk_adj_6502(2);
			break;
		/* BIT	imm (Zero Page) */
		case 0x24:
			temp_reg = reg->A & mem[mem[cpu_pin->t_addr.addr.addr_bus = ++sysreg->PC.pc.pc]];
			if (temp_reg & 0x80) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg & 0x40) {
				reg->P |= FLAG_V;
			}
			else {
				reg->P &= (unsigned char)~FLAG_V;
			}
			if (temp_reg == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(3);
			break;
		/* BIT	nn' (Absolute) */
		case 0x2c:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));

			temp_reg = reg->A & mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing];
			if (temp_reg & 0x80) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg & 0x40) {
				reg->P |= FLAG_V;
			}
			else {
				reg->P &= (unsigned char)~FLAG_V;
			}
			if (temp_reg == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(4);
			break;
		/* BMI	#imm */
		case 0x30:
			if (reg->P & FLAG_N) {
				sysreg->PC.pc.pc = (unsigned short)((sysreg->PC.pc.pc + 2) + (char)(mem[++sysreg->PC.pc.pc]));
				*cpuflag |= PCUPDT;
			}

			clk_adj_6502(2);
			break;
		/* BNE	#imm */
		case 0xd0:
			if (!(reg->P & FLAG_Z)) {
				sysreg->PC.pc.pc = (unsigned short)((sysreg->PC.pc.pc + 2) + (char)(mem[++sysreg->PC.pc.pc]));
				*cpuflag |= PCUPDT;
			}

			clk_adj_6502(2);
			break;
		/* BPL	#imm */
		case 0x10:
			if (!(reg->P & FLAG_N)) {
				sysreg->PC.pc.pc = (unsigned short)((sysreg->PC.pc.pc + 2) + (char)(mem[++sysreg->PC.pc.pc]));
				*cpuflag |= PCUPDT;
			}

			clk_adj_6502(2);
			break;
		/* BRK	#imm */
		case 0x00:
			sysreg->PC.pc.pc += 2;
			mem[--sysreg->S + 0x0100] = sysreg->PC.pc.t_pc.PCH;
			mem[--sysreg->S + 0x0100] = sysreg->PC.pc.t_pc.PCL;
			mem[--sysreg->S + 0x0100] = (reg->P | FLAG_Brk);
			reg->P |= FLAG_I;
			sysreg->PC.pc.t_pc.PCL = mem[0xfffe];
			sysreg->PC.pc.t_pc.PCH = mem[0xffff];
			*cpuflag |= PCUPDT;

			clk_adj_6502(7);
			break;
		/* BVC	#imm */
		case 0x50:
			if (!(reg->P & FLAG_V)) {
				sysreg->PC.pc.pc = (unsigned short)((sysreg->PC.pc.pc + 2) + (char)(mem[++sysreg->PC.pc.pc]));
				*cpuflag |= PCUPDT;
			}

			clk_adj_6502(2);
			break;
		/* BVS	#imm */
		case 0x70:
			if (reg->P & FLAG_V) {
				sysreg->PC.pc.pc = (unsigned short)((sysreg->PC.pc.pc + 2) + (char)(mem[++sysreg->PC.pc.pc]));
				*cpuflag |= PCUPDT;
			}

			clk_adj_6502(2);
			break;
		/* CLC */
		case 0x18:
			reg->P &= (unsigned char)~FLAG_C;

			clk_adj_6502(2);
			break;
		/* CLD */
		case 0xd8:
			reg->P &= (unsigned char)~FLAG_D;

			clk_adj_6502(2);
			break;
		/* CLI */
		case 0x58:
			reg->P &= (unsigned char)~FLAG_I;

			clk_adj_6502(2);
			break;
		/* CLV */
		case 0xb8:
			reg->P &= (unsigned char)~FLAG_V;

			clk_adj_6502(2);
			break;
		/* CMP	#imm */
		case 0xc9:
			temp_acr = (char)reg->A - (char)(cpu_pin->t_data.data.data_bus = mem[++sysreg->PC.pc.pc]);

			/* tOEIy[V */
			if ((char)(cpu_pin->t_data.data.data_bus) > (char)(reg->A)) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if (temp_acr < 0x00) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0x00) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(2);
			break;
		/* CMP	imm (Zero Page) */
		case 0xc5:
			temp_acr = (char)reg->A - (char)(cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]]);

			/* tOEIy[V */
			if ((char)(cpu_pin->t_data.data.data_bus) > (char)(reg->A)) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if (temp_acr < 0x00) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0x00) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(3);
			break;
		/* CMP	imm, X (Zero Page, X) */
		case 0xd5:
			temp_acr = (char)reg->A - (char)(cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X)]);

			/* tOEIy[V */
			if ((char)(cpu_pin->t_data.data.data_bus) > (char)(reg->A)) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if (temp_acr < 0x00) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0x00) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(4);
			break;
		/* CMP	nn' (Absolute) */
		case 0xcd:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			temp_acr = (char)reg->A - (char)(cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing]);

			/* tOEIy[V */
			if ((char)(cpu_pin->t_data.data.data_bus) > (char)(reg->A)) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if (temp_acr < 0x00) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0x00) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(4);
			break;
		/* CMP	nn', X (Absolute, X) */
		case 0xdd:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			ex_addressing += reg->X;
			temp_acr = (char)reg->A - (char)(cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing]);

			/* tOEIy[V */
			if ((char)(cpu_pin->t_data.data.data_bus) > (char)(reg->A)) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if (temp_acr < 0x00) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0x00) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(4);
			break;
		/* CMP	nn', Y (Absolute, Y) */
		case 0xd9:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			ex_addressing += reg->Y;
			temp_acr = (char)reg->A - (char)(cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing]);

			/* tOEIy[V */
			if ((char)(cpu_pin->t_data.data.data_bus) > (char)(reg->A)) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if (temp_acr < 0x00) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0x00) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(4);
			break;
		/* CMP	(imm, X) (Index Indirect) */
		case 0xc1:
			ex_addressing = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X);
			temp_acr = (char)reg->A - (char)(cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = mem[ex_addressing]]);

			/* tOEIy[V */
			if ((char)(cpu_pin->t_data.data.data_bus) > (char)(reg->A)) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if (temp_acr < 0x00) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0x00) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(6);
			break;
		/* CMP	(imm), Y (Indirect Index)  */
		case 0xd1:
			ex_addressing = (unsigned char)mem[++sysreg->PC.pc.pc];
			temp_acr = (char)reg->A - (char)(cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = (mem[ex_addressing] + reg->Y)]);

			/* tOEIy[V */
			if ((char)(cpu_pin->t_data.data.data_bus) > (char)(reg->A)) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if (temp_acr < 0x00) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0x00) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(5);
			break;
		/* CPX	#imm */
		case 0xe0:
			temp_acr = (char)reg->X - (char)(cpu_pin->t_data.data.data_bus = mem[++sysreg->PC.pc.pc]);

			/* tOEIy[V */
			if ((char)(cpu_pin->t_data.data.data_bus) > (char)(reg->X)) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if (temp_acr < 0x00) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0x00) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(2);
			break;
		/* CPX	imm (Zero Page) */
		case 0xe4:
			temp_acr = (char)reg->X - (char)(cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]]);

			/* tOEIy[V */
			if ((char)(cpu_pin->t_data.data.data_bus) > (char)(reg->X)) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if (temp_acr < 0x00) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0x00) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(3);
			break;
		/* CPX	nn' (Absolute) */
		case 0xec:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			temp_acr = (char)reg->X - (char)(cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing]);

			/* tOEIy[V */
			if ((char)(cpu_pin->t_data.data.data_bus) > (char)(reg->X)) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if (temp_acr < 0x00) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0x00) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(4);
			break;
		/* CPY	#imm */
		case 0xc0:
			temp_acr = (char)reg->Y - (char)(cpu_pin->t_data.data.data_bus = mem[++sysreg->PC.pc.pc]);

			/* tOEIy[V */
			if ((char)(cpu_pin->t_data.data.data_bus) > (char)(reg->Y)) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if (temp_acr < 0x00) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0x00) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(2);
			break;
		/* CPY	imm (Zero Page) */
		case 0xc4:
			temp_acr = (char)reg->Y - (char)(cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]]);

			/* tOEIy[V */
			if ((char)(cpu_pin->t_data.data.data_bus) > (char)(reg->Y)) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if (temp_acr < 0x00) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0x00) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(3);
			break;
		/* CPY	nn' (Absolute) */
		case 0xcc:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			temp_acr = (char)reg->Y - (char)(cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing]);

			/* tOEIy[V */
			if ((char)(cpu_pin->t_data.data.data_bus) > (char)(reg->Y)) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if (temp_acr < 0x00) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0x00) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(4);
			break;
		/* DEC	imm (Zero Page) */
		case 0xc6:
			temp_acr = (char)mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]] - (char)0x01;

			if (temp_acr < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus] = (unsigned char)temp_acr;
			*cpuflag |= MEMOUT;

			clk_adj_6502(5);
			break;
		/* DEC	imm, X (Zero Page, X) */
		case 0xd6:
			temp_acr = (char)mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X)] - (char)0x01;

			if (temp_acr < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus] = (unsigned char)temp_acr;
			*cpuflag |= MEMOUT;

			clk_adj_6502(6);
			break;
		/* DEC	nn' (Absolute) */
		case 0xce:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			temp_acr = (char)mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] - (char)0x01;

			if (temp_acr < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus] = (unsigned char)temp_acr;
			*cpuflag |= MEMOUT;

			clk_adj_6502(6);
			break;
		/* DEC	nn', X (Absolute, X) */
		case 0xde:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			ex_addressing += reg->X;
			temp_acr = (char)mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] - (char)0x01;

			if (temp_acr < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus] = (unsigned char)temp_acr;
			*cpuflag |= MEMOUT;

			clk_adj_6502(7);
			break;
		/* DEX */
		case 0xca:
			temp_acr = (char)reg->X - (char)0x01;

			if (temp_acr < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			reg->X = (unsigned char)temp_acr;

			clk_adj_6502(2);
			break;
		/* DEY */
		case 0x88:
			temp_acr = (char)reg->Y - (char)0x01;

			if (temp_acr < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			reg->Y = (unsigned char)temp_acr;

			clk_adj_6502(2);
			break;
		/* EOR	#imm */
		case 0x49:
			temp_reg1 = reg->A ^ (cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]]);

			if ((char)temp_reg1 < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			reg->A = (unsigned char)temp_reg1;

			clk_adj_6502(2);
			break;
		/* EOR	imm (Zero Page) */
		case 0x45:
			temp_reg1 = reg->A ^ mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]];

			if ((char)temp_reg1 < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			reg->A = (unsigned char)temp_reg1;

			clk_adj_6502(3);
			break;
		/* EOR	imm, X (Zero Page, X) */
		case 0x55:
			temp_reg1 = reg->A ^ mem[cpu_pin->t_addr.addr.addr_bus = (mem[++sysreg->PC.pc.pc] + reg->X)];

			if ((char)temp_reg1 < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			reg->A = (unsigned char)temp_reg1;

			clk_adj_6502(4);
			break;
		/* EOR	nn' (Absolute) */
		case 0x4d:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			temp_reg1 = reg->A ^ mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing];

			if ((char)temp_reg1 < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			reg->A = (unsigned char)temp_reg1;

			clk_adj_6502(4);
			break;
		/* EOR	nn', X (Absolute, X) */
		case 0x5d:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			ex_addressing += reg->X;
			temp_reg1 = reg->A ^ mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing];

			if ((char)temp_reg1 < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			reg->A = (unsigned char)temp_reg1;

			clk_adj_6502(4);
			break;
		/* EOR	nn', Y (Absolute, Y) */
		case 0x59:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			ex_addressing += reg->Y;
			temp_reg1 = reg->A ^ mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing];

			if ((char)temp_reg1 < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			reg->A = (unsigned char)temp_reg1;

			clk_adj_6502(4);
			break;
		/* EOR	(imm, X) (Index Indirect) */
		case 0x41:
			ex_addressing = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X);
			temp_reg1 = reg->A ^ (cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = mem[ex_addressing]]);

			if ((char)temp_reg1 < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			reg->A = (unsigned char)temp_reg1;

			clk_adj_6502(6);
			break;
		/* EOR	(imm), Y (Indirect Index) */
		case 0x51:
			ex_addressing = (unsigned char)mem[++sysreg->PC.pc.pc];
			temp_reg1 = reg->A ^ (cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = (mem[ex_addressing] + reg->Y)]);

			if ((char)temp_reg1 < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			reg->A = (unsigned char)temp_reg1;

			clk_adj_6502(5);
			break;
		/* INC	imm (Zero Page) */
		case 0xe6:
			temp_acr = (char)mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]] + (char)0x01;

			if (temp_acr < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus] = (unsigned char)temp_acr;
			*cpuflag |= MEMOUT;

			clk_adj_6502(5);
			break;
		/* INC	imm, X (Zero Page, X) */
		case 0xf6:
			temp_acr = (char)mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X)] + (char)0x01;

			if (temp_acr < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus] = (unsigned char)temp_acr;
			*cpuflag |= MEMOUT;

			clk_adj_6502(6);
			break;
		/* INC	nn' (Absolute) */
		case 0xee:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			temp_acr = (char)mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] + (char)0x01;

			if (temp_acr < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus] = (unsigned char)temp_acr;
			*cpuflag |= MEMOUT;

			clk_adj_6502(6);
			break;
		/* INC	nn', X (Absolute, X) */
		case 0xfe:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			ex_addressing += reg->X;
			temp_acr = (char)mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] + (char)0x01;

			if (temp_acr < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus] = (unsigned char)temp_acr;
			*cpuflag |= MEMOUT;

			clk_adj_6502(7);
			break;
		/* INX */
		case 0xe8:
			temp_acr = (char)reg->X + (char)0x01;

			if (temp_acr < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			reg->X = (unsigned char)temp_acr;

			clk_adj_6502(2);
			break;
		/* INY */
		case 0xc8:
			temp_acr = (char)reg->Y + (char)0x01;

			if (temp_acr < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_acr == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			reg->Y = (unsigned char)temp_acr;

			clk_adj_6502(2);
			break;
		/* JMP (Absolute) */
		case 0x4c:
			temp_reg1 = mem[++sysreg->PC.pc.pc];
			temp_reg2 = mem[++sysreg->PC.pc.pc];
			sysreg->PC.pc.t_pc.PCL = temp_reg1;
			sysreg->PC.pc.t_pc.PCH = temp_reg2;
			*cpuflag |= PCUPDT;

			clk_adj_6502(3);
			break;
		/* JMP (Indirect) */
		case 0x6c:
			temp_reg1 = mem[mem[++sysreg->PC.pc.pc]];
			temp_reg2 = mem[mem[++sysreg->PC.pc.pc]];
			sysreg->PC.pc.t_pc.PCL = temp_reg1;
			sysreg->PC.pc.t_pc.PCH = temp_reg2;
			*cpuflag |= PCUPDT;

			clk_adj_6502(5);
			break;
		/* JSR (Absolute) */
		case 0x20:
			temp_reg1 = mem[++sysreg->PC.pc.pc];
			temp_reg2 = mem[++sysreg->PC.pc.pc];
			sysreg->PC.pc.pc += 1;
			mem[--sysreg->S + 0x0100] = sysreg->PC.pc.t_pc.PCH;
			mem[--sysreg->S + 0x0100] = sysreg->PC.pc.t_pc.PCL;
			sysreg->PC.pc.t_pc.PCL = temp_reg1;
			sysreg->PC.pc.t_pc.PCH = temp_reg2;
			*cpuflag |= PCUPDT;

			clk_adj_6502(6);
			break;
		/* LDA	#imm */
		case 0xa9:
			reg->A = cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = ++sysreg->PC.pc.pc];
			if ((char)reg->A < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->A == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(2);
			break;
		/* LDA	imm (Zero Page) */
		case 0xa5:
			reg->A = cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]];
			if ((char)reg->A < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->A == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(3);
			break;
		/* LDA	imm, X (Zero Page, X) */
		case 0xb5:
			reg->A = cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X)];
			if ((char)reg->A < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->A == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(4);
			break;
		/* LDA	nn' (Absolute) */
		case 0xad:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			reg->A = cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing];
			if ((char)reg->A < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->A == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(4);
			break;
		/* LDA	nn', X (Absolute, X) */
		case 0xbd:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			ex_addressing += reg->X;
			reg->A = cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing];
			if ((char)reg->A < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->A == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(4);
			break;
		/* LDA	nn', Y (Absolute, Y) */
		case 0xb9:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			ex_addressing += reg->Y;
			reg->A = cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing];
			if ((char)reg->A < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->A == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(4);
			break;
		/* LDA	(imm, X) (Index Indirect) */
		case 0xa1:
			ex_addressing = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X);
			reg->A = cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = mem[ex_addressing]];
			if ((char)reg->A < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->A == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(6);
			break;
		/* LDA	(imm), Y (Indirect Index) */
		case 0xb1:
			ex_addressing = (unsigned char)mem[++sysreg->PC.pc.pc];
			reg->A = cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = (mem[ex_addressing] + reg->Y)];
			if ((char)reg->A < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->A == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(5);
			break;
		/* LDX	#imm */
		case 0xa2:
			reg->X = cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = ++sysreg->PC.pc.pc];
			if ((char)reg->X < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->X == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(2);
			break;
		/* LDX	imm (Zero Page) */
		case 0xa6:
			reg->X = cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]];
			if ((char)reg->X < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->X == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(3);
			break;
		/* LDX	imm, Y (Zero Page, Y) */
		case 0xb6:
			reg->X = cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->Y)];
			if ((char)reg->X < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->X == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(4);
			break;
		/* LDX	nn' (Absolute) */
		case 0xae:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			reg->X = cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing];
			if ((char)reg->X < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->X == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(4);
			break;
		/* LDX	nn', Y (Absolute, Y) */
		case 0xbe:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			ex_addressing += reg->Y;
			reg->X = cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing];
			if ((char)reg->X < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->X == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(4);
			break;
		/* LDY	#imm */
		case 0xa0:
			reg->Y = cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = ++sysreg->PC.pc.pc];
			if ((char)reg->Y < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->Y == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(2);
			break;
		/* LDY	imm (Zero Page) */
		case 0xa4:
			reg->Y = cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]];
			if ((char)reg->Y < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->Y == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(3);
			break;
		/* LDY	imm, X (Zero Page, X) */
		case 0xb4:
			reg->Y = cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X)];
			if ((char)reg->Y < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->Y == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(4);
			break;
		/* LDY	nn' (Absolute) */
		case 0xac:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			reg->Y = cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing];
			if ((char)reg->Y < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->Y == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(4);
			break;
		/* LDY	nn', X (Absolute, X) */
		case 0xbc:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			ex_addressing += reg->X;
			reg->Y = cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing];
			if ((char)reg->Y < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->Y == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(4);
			break;
		/* LSR	A */
		case 0x4a:
			temp_reg1 = ((reg->A >> 1) & (unsigned char)~0x80);
			if (reg->A & 0x01) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}
			reg->A = temp_reg1;

			clk_adj_6502(2);
			break;
		/* LSR	imm (Zero Page) */
		case 0x46:
			temp_reg1 = ((mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]] >> 1) & (unsigned char)~0x80);
			if (mem[cpu_pin->t_addr.addr.addr_bus] & 0x01) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}
			cpu_pin->t_data.data.data_bus = mem[mem[sysreg->PC.pc.pc]] = temp_reg1;
			*cpuflag |= MEMOUT;

			clk_adj_6502(5);
			break;
		/* LSR	imm, X (Zero Page, X) */
		case 0x56:
			temp_reg1 = ((mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X)] >> 1) & (unsigned char)~0x80);
			if (mem[cpu_pin->t_addr.addr.addr_bus] & 0x01) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}
			cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus] = temp_reg1;
			*cpuflag |= MEMOUT;

			clk_adj_6502(6);
			break;
		/* LSR	nn' (Absolute) */
		case 0x4e:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			temp_reg1 = ((mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] >> 1) & (unsigned char)~0x80);
			if (mem[ex_addressing] & 0x01) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}
			cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus] = temp_reg1;
			*cpuflag |= MEMOUT;

			clk_adj_6502(6);
			break;
		/* LSR	nn', X (Absolute, X) */
		case 0x5e:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			ex_addressing += reg->X;
			temp_reg1 = ((mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] >> 1) & (unsigned char)~0x80);
			if (mem[ex_addressing] & 0x01) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}
			cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus] = temp_reg1;
			*cpuflag |= MEMOUT;

			clk_adj_6502(7);
			break;
		/* NOP */
		case 0xea:
			/*
			 *	Ȃ
			 */

			clk_adj_6502(2);
			break;
		/* ORA	#imm */
		case 0x09:
			reg->A |= mem[++sysreg->PC.pc.pc];
			if ((char)reg->A < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->A == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(2);
			break;
		/* ORA	imm (Zero Page) */
		case 0x05:
			reg->A |= mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]];
			if ((char)reg->A < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->A == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(3);
			break;
		/* ORA	imm, X (Zero Page, X) */
		case 0x15:
			reg->A |= mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X)];
			if ((char)reg->A < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->A == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(4);
			break;
		/* ORA	nn' (Absolute) */
		case 0x0d:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			reg->A |= cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing];
			if ((char)reg->A < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->A == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(4);
			break;
		/* ORA	nn', X (Absolute, X) */
		case 0x1d:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			ex_addressing += reg->X;
			reg->A |= cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing];
			if ((char)reg->A < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->A == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(4);
			break;
		/* ORA	nn', Y (Absolute, Y) */
		case 0x19:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			ex_addressing += reg->Y;
			reg->A |= cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing];
			if ((char)reg->A < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->A == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(4);
			break;
		/* ORA	(imm, X) (Index Indirect) */
		case 0x01:
			ex_addressing = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X);
			reg->A |= cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = mem[ex_addressing]];
			if ((char)reg->A < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->A == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(6);
			break;
		/* ORA	(imm), Y (Indirect Index) */
		case 0x11:
			ex_addressing = (unsigned char)mem[++sysreg->PC.pc.pc];
			reg->A |= cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = (mem[ex_addressing] + reg->Y)];
			if ((char)reg->A < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->A == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(5);
			break;
		/* PHA */
		case 0x48:
			mem[--sysreg->S + 0x0100] = reg->A;

			clk_adj_6502(3);
			break;
		/* PHP */
		case 0x08:
			mem[--sysreg->S + 0x0100] = reg->P;

			clk_adj_6502(3);
			break;
		/* PLA */
		case 0x68:
			reg->A = mem[(sysreg->S++) + 0x0100];

			if ((char)reg->A < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->A == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(4);
			break;
		/* PLP */
		case 0x28:
			reg->P = mem[(sysreg->S++) + 0x0100];

			clk_adj_6502(4);
			break;
		/* ROL	A */
		case 0x2a:
			temp_reg1 = (unsigned char)(reg->A << 1);
			if (reg->P & FLAG_C) {
				temp_reg1 |= 0x01;
			}
			else {
				temp_reg1 &= (unsigned char)~0x01;
			}
			if (reg->A & 0x80) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if ((char)temp_reg1 < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			reg->A = temp_reg1;

			clk_adj_6502(2);
			break;
		/* ROL	imm (Zero Page) */
		case 0x26:
			temp_reg1 = (unsigned char)(mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]] << 1);
			if (reg->P & FLAG_C) {
				temp_reg1 |= 0x01;
			}
			else {
				temp_reg1 &= (unsigned char)~0x01;
			}
			if (mem[cpu_pin->t_addr.addr.addr_bus] & 0x80) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if ((char)temp_reg1 < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			mem[cpu_pin->t_addr.addr.addr_bus] = cpu_pin->t_data.data.data_bus = temp_reg1;
			*cpuflag |= MEMOUT;

			clk_adj_6502(5);
			break;
		/* ROL	 imm, X (Zero Page, X) */
		case 0x36:
			temp_reg1 = (unsigned char)(mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X)] << 1);
			if (reg->P & FLAG_C) {
				temp_reg1 |= 0x01;
			}
			else {
				temp_reg1 &= (unsigned char)~0x01;
			}
			if (mem[cpu_pin->t_addr.addr.addr_bus] & 0x80) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if ((char)temp_reg1 < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			mem[cpu_pin->t_addr.addr.addr_bus] = cpu_pin->t_data.data.data_bus = temp_reg1;
			*cpuflag |= MEMOUT;

			clk_adj_6502(6);
			break;
		/* ROL	nn' (Absolute) */
		case 0x2e:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			temp_reg1 = cpu_pin->t_data.data.data_bus = (unsigned char)(mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] << 1);
			if (reg->P & FLAG_C) {
				temp_reg1 |= 0x01;
			}
			else {
				temp_reg1 &= (unsigned char)~0x01;
			}
			if (mem[cpu_pin->t_addr.addr.addr_bus] & 0x80) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if ((char)temp_reg1 < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			mem[cpu_pin->t_addr.addr.addr_bus] = cpu_pin->t_data.data.data_bus = temp_reg1;
			*cpuflag |= MEMOUT;

			clk_adj_6502(6);
			break;
		/* ROL	nn', X (Absolute, X) */
		case 0x3e:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			ex_addressing += reg->X;
			temp_reg1 = cpu_pin->t_data.data.data_bus = (unsigned char)(mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] << 1);
			if (reg->P & FLAG_C) {
				temp_reg1 |= 0x01;
			}
			else {
				temp_reg1 &= (unsigned char)~0x01;
			}
			if (mem[cpu_pin->t_addr.addr.addr_bus] & 0x80) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if ((char)temp_reg1 < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			mem[cpu_pin->t_addr.addr.addr_bus] = temp_reg1;
			*cpuflag |= MEMOUT;

			clk_adj_6502(7);
			break;
		/* ROR	A */
		case 0x6a:
			temp_reg1 = (unsigned char)(reg->A >> 1);
			if (reg->P & FLAG_C) {
				temp_reg1 |= 0x80;
			}
			else {
				temp_reg1 &= (unsigned char)~0x80;
			}
			if (reg->A & 0x01) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if ((char)temp_reg1 < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			reg->A = temp_reg1;

			clk_adj_6502(2);
			break;
		/* ROR	imm (Zero Page) */
		case 0x66:
			temp_reg1 = (unsigned char)(mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]] >> 1);
			if (reg->P & FLAG_C) {
				temp_reg1 |= 0x80;
			}
			else {
				temp_reg1 &= (unsigned char)~0x80;
			}
			if (mem[cpu_pin->t_addr.addr.addr_bus] & 0x01) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if ((char)temp_reg1 < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			mem[cpu_pin->t_addr.addr.addr_bus] = cpu_pin->t_data.data.data_bus = temp_reg1;
			*cpuflag |= MEMOUT;

			clk_adj_6502(5);
			break;
		/* ROR	imm, X (Zero Page, X) */
		case 0x76:
			temp_reg1 = (unsigned char)(mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X)] >> 1);
			if (reg->P & FLAG_C) {
				temp_reg1 |= 0x80;
			}
			else {
				temp_reg1 &= (unsigned char)~0x80;
			}
			if (mem[cpu_pin->t_addr.addr.addr_bus] & 0x01) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if ((char)temp_reg1 < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			mem[cpu_pin->t_addr.addr.addr_bus] = cpu_pin->t_data.data.data_bus = temp_reg1;
			*cpuflag |= MEMOUT;

			clk_adj_6502(6);
			break;
		/* ROR	nn' (Absolute) */
		case 0x6e:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			temp_reg1 = (unsigned char)(mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] >> 1);
			if (reg->P & FLAG_C) {
				temp_reg1 |= 0x80;
			}
			else {
				temp_reg1 &= (unsigned char)~0x80;
			}
			if (mem[cpu_pin->t_addr.addr.addr_bus] & 0x01) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if ((char)temp_reg1 < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			mem[cpu_pin->t_addr.addr.addr_bus] = cpu_pin->t_data.data.data_bus = temp_reg1;
			*cpuflag |= MEMOUT;

			clk_adj_6502(6);
			break;
		/* ROR	nn', X (Absolute, X) */
		case 0x7e:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			ex_addressing += reg->X;
			temp_reg1 = (unsigned char)(mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] >> 1);
			if (reg->P & FLAG_C) {
				temp_reg1 |= 0x80;
			}
			else {
				temp_reg1 &= (unsigned char)~0x80;
			}
			if (mem[cpu_pin->t_addr.addr.addr_bus] & 0x01) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if ((char)temp_reg1 < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg1 == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			/* Zʊi[ */
			mem[cpu_pin->t_addr.addr.addr_bus] = cpu_pin->t_data.data.data_bus = temp_reg1;
			*cpuflag |= MEMOUT;

			clk_adj_6502(7);
			break;
		/* RTI */
		case 0x40:
			reg->P = mem[(sysreg->S++) + 0x0100];
			sysreg->PC.pc.t_pc.PCL = mem[(sysreg->S++) + 0x0100];
			sysreg->PC.pc.t_pc.PCH = mem[(sysreg->S++) + 0x0100];
			*cpuflag |= PCUPDT;

			clk_adj_6502(6);
			break;
		/* RTS */
		case 0x60:
			sysreg->PC.pc.t_pc.PCL = mem[(sysreg->S++) + 0x0100];
			sysreg->PC.pc.t_pc.PCH = mem[(sysreg->S++) + 0x0100];
			sysreg->PC.pc.pc += 1;
			*cpuflag |= PCUPDT;

			clk_adj_6502(6);
			break;
		/* SBC	#imm */
		case 0xe9:
			temp_reg = (unsigned short)reg->A - (unsigned short)mem[++sysreg->PC.pc.pc] - (unsigned short)(reg->P & FLAG_C);
			if ((short)temp_reg < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}
			if (temp_reg > 0xff) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if (temp_reg & 0x40) {
				reg->P |= FLAG_V;
			}
			else {
				reg->P &= (unsigned char)~FLAG_V;
			}

			/* Zʊi[ */
			reg->A = (unsigned char)temp_reg;

			clk_adj_6502(2);
			break;
		/* SBC	imm (Zero Page) */
		case 0xe5:
			temp_reg = (unsigned short)reg->A - (unsigned short)mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]] - (unsigned short)(reg->P & FLAG_C);
			if ((short)temp_reg < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}
			if (temp_reg > 0xff) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if (temp_reg & 0x40) {
				reg->P |= FLAG_V;
			}
			else {
				reg->P &= (unsigned char)~FLAG_V;
			}

			/* Zʊi[ */
			reg->A = (unsigned char)temp_reg;

			clk_adj_6502(3);
			break;
		/* SBC	imm, X (Zero Page, X) */
		case 0xf5:
			temp_reg = (unsigned short)reg->A - (unsigned short)mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X)] - (unsigned short)(reg->P & FLAG_C);
			if ((short)temp_reg < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}
			if (temp_reg > 0xff) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if (temp_reg & 0x40) {
				reg->P |= FLAG_V;
			}
			else {
				reg->P &= (unsigned char)~FLAG_V;
			}

			/* Zʊi[ */
			reg->A = (unsigned char)temp_reg;

			clk_adj_6502(4);
			break;
		/* SBC	nn' (Absolute) */
		case 0xed:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			temp_reg = (unsigned short)reg->A - (unsigned short)mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] - (unsigned short)(reg->P & FLAG_C);
			if ((short)temp_reg < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}
			if (temp_reg > 0xff) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if (temp_reg & 0x40) {
				reg->P |= FLAG_V;
			}
			else {
				reg->P &= (unsigned char)~FLAG_V;
			}

			/* Zʊi[ */
			reg->A = (unsigned char)temp_reg;

			clk_adj_6502(4);
			break;
		/* SBC	nn', X (Absolute, X) */
		case 0xfd:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			ex_addressing += reg->X;
			temp_reg = (unsigned short)reg->A - (unsigned short)mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] - (unsigned short)(reg->P & FLAG_C);
			if ((short)temp_reg < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}
			if (temp_reg > 0xff) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if (temp_reg & 0x40) {
				reg->P |= FLAG_V;
			}
			else {
				reg->P &= (unsigned char)~FLAG_V;
			}

			/* Zʊi[ */
			reg->A = (unsigned char)temp_reg;

			clk_adj_6502(4);
			break;
		/* SBC	nn', Y (Absolute, Y) */
		case 0xf9:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			ex_addressing += reg->Y;
			temp_reg = (unsigned short)reg->A - (unsigned short)mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] - (unsigned short)(reg->P & FLAG_C);
			if ((short)temp_reg < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}
			if (temp_reg > 0xff) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if (temp_reg & 0x40) {
				reg->P |= FLAG_V;
			}
			else {
				reg->P &= (unsigned char)~FLAG_V;
			}

			/* Zʊi[ */
			reg->A = (unsigned char)temp_reg;

			clk_adj_6502(4);
			break;
		/* SBC	(imm, X) (Index Indirect) */
		case 0xe1:
			ex_addressing = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X);
			temp_reg = (unsigned short)reg->A - (unsigned short)mem[cpu_pin->t_addr.addr.addr_bus = mem[ex_addressing]] - (unsigned short)(reg->P & FLAG_C);
			if ((short)temp_reg < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}
			if (temp_reg > 0xff) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if (temp_reg & 0x40) {
				reg->P |= FLAG_V;
			}
			else {
				reg->P &= (unsigned char)~FLAG_V;
			}

			/* Zʊi[ */
			reg->A = (unsigned char)temp_reg;

			clk_adj_6502(6);
			break;
		/* SBC	(imm), Y (Indirect Index) */
		case 0xf1:
			ex_addressing = (unsigned char)mem[++sysreg->PC.pc.pc];
			temp_reg = (unsigned short)reg->A - (unsigned short)mem[cpu_pin->t_addr.addr.addr_bus = (mem[ex_addressing] + reg->Y)] - (unsigned short)(reg->P & FLAG_C);
			if ((short)temp_reg < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (temp_reg == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}
			if (temp_reg > 0xff) {
				reg->P |= FLAG_C;
			}
			else {
				reg->P &= (unsigned char)~FLAG_C;
			}
			if (temp_reg & 0x40) {
				reg->P |= FLAG_V;
			}
			else {
				reg->P &= (unsigned char)~FLAG_V;
			}

			/* Zʊi[ */
			reg->A = (unsigned char)temp_reg;

			clk_adj_6502(5);
			break;
		/* SEC */
		case 0x38:
			reg->P |= FLAG_C;

			clk_adj_6502(2);
			break;
		/* SED */
		case 0xf8:
			reg->P |= FLAG_D;

			clk_adj_6502(2);
			break;
		/* SEI */
		case 0x78:
			reg->P |= FLAG_I;

			clk_adj_6502(2);
			break;
		/* STA	imm (Zero Page) */
		case 0x85:
			mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]] = reg->A;
			*cpuflag |= MEMOUT;

			clk_adj_6502(3);
			break;
		/* STA	imm, X (Zero Page, X) */
		case 0x95:
			mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X)] = reg->A;
			*cpuflag |= MEMOUT;

			clk_adj_6502(4);
			break;
		/* STA	nn' (Absolute) */
		case 0x8d:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] = reg->A;
			*cpuflag |= MEMOUT;

			clk_adj_6502(4);
			break;
		/* STA	nn', X (Absolute, X) */
		case 0x9d:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			ex_addressing += reg->X;
			mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] = reg->A;
			*cpuflag |= MEMOUT;

			clk_adj_6502(5);
			break;
		/* STA	nn', Y (Absolute, Y) */
		case 0x99:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			ex_addressing += reg->Y;
			mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] = reg->A;
			*cpuflag |= MEMOUT;

			clk_adj_6502(5);
			break;
		/* STA	(imm, X) (Index Indirect) */
		case 0x81:
			ex_addressing = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X);
			mem[cpu_pin->t_addr.addr.addr_bus = mem[ex_addressing]] = reg->A;
			*cpuflag |= MEMOUT;

			clk_adj_6502(6);
			break;
		/* STA	(imm), Y (Indirect Index) */
		case 0x91:
			ex_addressing = (unsigned char)mem[++sysreg->PC.pc.pc];
			mem[cpu_pin->t_addr.addr.addr_bus = (mem[ex_addressing] + reg->Y)] = reg->A;
			*cpuflag |= MEMOUT;

			clk_adj_6502(6);
			break;
		/* STX	imm (Zero Page) */
		case 0x86:
			mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]] = reg->X;
			*cpuflag |= MEMOUT;

			clk_adj_6502(3);
			break;
		/* STX	imm, Y (Zero Page, Y) */
		case 0x96:
			mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->Y)] = reg->X;
			*cpuflag |= MEMOUT;

			clk_adj_6502(4);
			break;
		/* STX	nn' (Absolute) */
		case 0x8e:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] = reg->X;
			*cpuflag |= MEMOUT;

			clk_adj_6502(4);
			break;
		/* STY	imm (Zero Page) */
		case 0x84:
			mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]] = reg->Y;
			*cpuflag |= MEMOUT;

			clk_adj_6502(3);
			break;
		/* STY	imm, X (Zero Page, X) */
		case 0x94:
			mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X)] = reg->Y;
			*cpuflag |= MEMOUT;

			clk_adj_6502(4);
			break;
		/* STY	nn' (Absolute) */
		case 0x8c:
			ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
			mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] = reg->Y;
			*cpuflag |= MEMOUT;

			clk_adj_6502(4);
			break;
		/* TAX */
		case 0xaa:
			reg->X = reg->A;
			if ((char)reg->X < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->X == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(2);
			break;
		/* TAY */
		case 0xa8:
			reg->Y = reg->A;
			if ((char)reg->Y < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->Y == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}
			break;
		/* TSX */
		case 0xba:
			reg->X = sysreg->S;
			if ((char)reg->X < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->X == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(2);
			break;
		/* TXA */
		case 0x8a:
			reg->A = reg->X;
			if ((char)reg->A < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->A == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(2);
			break;
		/* TXS */
		case 0x9a:
			sysreg->S = reg->X;
			if ((char)sysreg->S < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (sysreg->S == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(2);
			break;
		/* TYA */
		case 0x98:
			reg->A = reg->Y;
			if ((char)reg->A < 0) {
				reg->P |= FLAG_N;
			}
			else {
				reg->P &= (unsigned char)~FLAG_N;
			}
			if (reg->A == 0) {
				reg->P |= FLAG_Z;
			}
			else {
				reg->P &= (unsigned char)~FLAG_Z;
			}

			clk_adj_6502(2);
			break;
		case 0x02:
			switch (cpukind) {
				/* HLT */
				case MOS6502:
					halt = CPU_HALT;

					clk_adj_6502(2);
					break;
				/* KIL */
				case RP2A03:
					clk_adj_6502(1);
					break;
				/* SXY */
				case HuC6280:
					temp_reg1 = reg->X;
					reg->X = reg->Y;
					reg->Y = temp_reg1;

					reg->P &= (unsigned char)~FLAG_T;

					clk_adj_6502(3);
					break;
				case W65C02:
				default:
					break;
			}
			break;
		case 0x03:
			switch (cpukind) {
				/* ASO	(imm, X) (Index Indirect) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X);
					temp_reg = (unsigned short)(mem[cpu_pin->t_addr.addr.addr_bus = mem[ex_addressing]] << 1);
					if (temp_reg & 0x0100) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}

					reg->A |= (mem[cpu_pin->t_addr.addr.addr_bus] = (unsigned char)temp_reg);
					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					clk_adj_6502(8);
					break;
				/* ST0 */
				case HuC6280:
					vdc[0x0000] = mem[++sysreg->PC.pc.pc];

					reg->P &= (unsigned char)~FLAG_T;

					*cpuflag |= VDCOUT;

					clk_adj_6502(5);
					break;
				case W65C02:
				default:
					break;
			}
			break;
		case 0x04:
			switch (cpukind) {
				/* SKB */
				case MOS6502:
				case RP2A03:
					sysreg->PC.pc.pc++;
					*cpuflag |= PCUPDT;
					clk_adj_6502(4);
					break;
				/* TSB	imm (Zero Page) */
				case W65C02:
				case HuC6280:
					temp_reg1 = reg->A | mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]];
					if (reg->A & mem[cpu_pin->t_addr.addr.addr_bus]) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					/* Zʊi[ */
					mem[cpu_pin->t_addr.addr.addr_bus] = temp_reg1;
					*cpuflag |= MEMOUT;

					clk_adj_6502(5);
					break;
				default:
					break;
			}
			break;
		case 0x07:
			switch (cpukind) {
				/* ASO	imm (Zero Page) */
				case MOS6502:
				case RP2A03:
					temp_reg = (unsigned short)(mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]] << 1);
					if (temp_reg & 0x0100) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}

					reg->A |= (mem[cpu_pin->t_addr.addr.addr_bus] = (unsigned char)temp_reg);
					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					clk_adj_6502(8);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x0b:
			switch (cpukind) {
				/* ANC	#imm */
				case MOS6502:
				case RP2A03:
					temp_reg1 = reg->A & mem[cpu_pin->t_addr.addr.addr_bus = ++sysreg->PC.pc.pc];

					if ((char)temp_reg1 < 0) {
						reg->P |= (FLAG_C | FLAG_N);
					}
					else {
						reg->P &= (unsigned char)~(FLAG_C | FLAG_N);
					}
					if (temp_reg1 == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					reg->A = temp_reg1;

					clk_adj_6502(2);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x0c:
			switch (cpukind) {
				/* SKW */
				case MOS6502:
				case RP2A03:
					sysreg->PC.pc.pc += 2;
					*cpuflag |= PCUPDT;
					clk_adj_6502(4);
					break;
				/* TSB	nn' (Absolute) */
				case W65C02:
				case HuC6280:
					ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					temp_reg1 = reg->A | mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing];
					if (reg->A & mem[cpu_pin->t_addr.addr.addr_bus]) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					/* Zʊi[ */
					mem[cpu_pin->t_addr.addr.addr_bus] = temp_reg1;
					*cpuflag |= MEMOUT;

					clk_adj_6502(6);
					break;
				default:
					break;
			}
			break;
		case 0x0f:
			switch (cpukind) {
				/* ASO	nn' (Absolute) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					temp_reg = (unsigned short)(mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] << 1);
					if (temp_reg & 0x0100) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}

					reg->A |= (mem[cpu_pin->t_addr.addr.addr_bus] = (unsigned char)temp_reg);
					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					clk_adj_6502(8);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x12:
			switch (cpukind) {
				/* HLT */
				case MOS6502:
					halt = CPU_HALT;

					clk_adj_6502(2);
					break;
				/* KIL */
				case RP2A03:
					clk_adj_6502(1);
					break;
				/* ORA	imm ((Zero Page)) */
				case W65C02:
				case HuC6280:
					ex_addressing  = mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]];
					ex_addressing |= ((mem[++(cpu_pin->t_addr.addr.addr_bus)] << 0x08) & 0xff00);
					reg->A |= mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing];
					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					clk_adj_6502(5);
					break;
				default:
					break;
			}
			break;
		case 0x13:
			switch (cpukind) {
				/* ASO	(imm), Y (Indirect Index) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned char)mem[++sysreg->PC.pc.pc];
					temp_reg = (unsigned short)(mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[ex_addressing] + reg->Y)] << 1);
					if (temp_reg & 0x0100) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}

					reg->A |= (mem[cpu_pin->t_addr.addr.addr_bus] = (unsigned char)temp_reg);
					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					clk_adj_6502(8);
					break;
				/* ST1 */
				case HuC6280:
					vdc[0x0002] = mem[++sysreg->PC.pc.pc];

					reg->P &= (unsigned char)~FLAG_T;

					*cpuflag |= VDCOUT;

					clk_adj_6502(5);
					break;
				case W65C02:
				default:
					break;
			}
			break;
		case 0x14:
			switch (cpukind) {
				/* SKB */
				case MOS6502:
				case RP2A03:
					sysreg->PC.pc.pc++;
					*cpuflag |= PCUPDT;
					clk_adj_6502(4);
					break;
				/* TRB	imm (Zero Page) */
				case W65C02:
				case HuC6280:
					temp_reg1 = ~(reg->A) & mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]];
					if (temp_reg1 == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					/* Zʊi[ */
					mem[cpu_pin->t_addr.addr.addr_bus] = temp_reg1;
					*cpuflag |= MEMOUT;

					clk_adj_6502(5);
					break;
				default:
					break;
			}
			break;
		case 0x17:
			switch (cpukind) {
				/* ASO	imm, X (Zero Page, X) */
				case MOS6502:
				case RP2A03:
					temp_reg = (unsigned short)(mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X)] << 1);
					if (temp_reg & 0x0100) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}

					reg->A |= (mem[cpu_pin->t_addr.addr.addr_bus] = (unsigned char)temp_reg);
					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					clk_adj_6502(6);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x1a:
			switch (cpukind) {
				/* NOP */
				case MOS6502:
				case RP2A03:
					clk_adj_6502(2);
					break;
				/* INA */
				case W65C02:
				case HuC6280:
					reg->A += 1;

					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					clk_adj_6502(2);
					break;
				default:
					break;
			}
			break;
		case 0x1b:
			switch (cpukind) {
				/* ASO	imm, Y (Zero Page, Y) */
				case MOS6502:
				case RP2A03:
					temp_reg = (unsigned short)(mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->Y)] << 1);
					if (temp_reg & 0x0100) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}

					reg->A |= (mem[cpu_pin->t_addr.addr.addr_bus] = (unsigned char)temp_reg);
					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					clk_adj_6502(8);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x1c:
			switch (cpukind) {
				/* SKW */
				case MOS6502:
				case RP2A03:
					sysreg->PC.pc.pc += 2;
					*cpuflag |= PCUPDT;
					clk_adj_6502(4);
					break;
				/* TRB	nn', X (Absolute, X) */
				case W65C02:
				case HuC6280:
					ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					temp_reg1 = ~(reg->A) & mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing];
					if (temp_reg1 == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					/* Zʊi[ */
					mem[cpu_pin->t_addr.addr.addr_bus] = temp_reg1;
					*cpuflag |= MEMOUT;

					clk_adj_6502(6);
					break;
				default:
					break;
			}
			break;
		case 0x1f:
			switch (cpukind) {
				/* ASO	nn', X (Absolute, X) */
				case MOS6502:
				case W65C02:
				case RP2A03:
				case HuC6280:
					ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					ex_addressing += reg->X;
					temp_reg = (unsigned short)(mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] << 1);
					if (temp_reg & 0x0100) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}

					reg->A |= (mem[cpu_pin->t_addr.addr.addr_bus] = (unsigned char)temp_reg);
					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					clk_adj_6502(7);
					break;
				default:
					break;
			}
			break;
		case 0x22:
			switch (cpukind) {
				/* HLT */
				case MOS6502:
					halt = CPU_HALT;

					clk_adj_6502(2);
					break;
				/* KIL */
				case RP2A03:
					clk_adj_6502(1);
					break;
				/* SAX */
				case HuC6280:
					temp_reg1 = reg->A;
					reg->A = reg->X;
					reg->X = temp_reg1;

					reg->P &= (unsigned char)~FLAG_T;

					clk_adj_6502(3);
					break;
				case W65C02:
				default:
					break;
			}
			break;
		case 0x23:
			switch (cpukind) {
				/* RLA	 (imm, X) (Index Indirect) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X);
					temp_reg1 = (unsigned char)(mem[cpu_pin->t_addr.addr.addr_bus = mem[ex_addressing]] << 1);
					if (reg->P & FLAG_C) {
						temp_reg1 |= 0x01;
					}
					else {
						temp_reg1 &= (unsigned char)~0x01;
					}
					if (mem[cpu_pin->t_addr.addr.addr_bus] & 0x80) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}

					/* Zʊi[ */
					reg->A |= mem[cpu_pin->t_addr.addr.addr_bus] = cpu_pin->t_data.data.data_bus = temp_reg1;

					/* tOEIy[V */
					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					*cpuflag |= MEMOUT;

					clk_adj_6502(8);
					break;
				/* ST2 */
				case HuC6280:
					vdc[0x0003] = mem[++sysreg->PC.pc.pc];

					reg->P &= (unsigned char)~FLAG_T;

					*cpuflag |= VDCOUT;

					clk_adj_6502(5);
					break;
				case W65C02:
				default:
					break;
			}
			break;
		case 0x27:
			switch (cpukind) {
				/* RLA	 imm (Zero Page) */
				case MOS6502:
				case RP2A03:
					temp_reg1 = (unsigned char)(mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]] << 1);
					if (reg->P & FLAG_C) {
						temp_reg1 |= 0x01;
					}
					else {
						temp_reg1 &= (unsigned char)~0x01;
					}
					if (mem[cpu_pin->t_addr.addr.addr_bus] & 0x80) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}

					/* Zʊi[ */
					reg->A |= mem[cpu_pin->t_addr.addr.addr_bus] = cpu_pin->t_data.data.data_bus = temp_reg1;

					/* tOEIy[V */
					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					*cpuflag |= MEMOUT;

					clk_adj_6502(5);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x2b:
			switch (cpukind) {
				/* ANC	#imm */
				case MOS6502:
				case RP2A03:
					temp_reg1 = reg->A & mem[cpu_pin->t_addr.addr.addr_bus = ++sysreg->PC.pc.pc];

					if ((char)temp_reg1 < 0) {
						reg->P |= (FLAG_C | FLAG_N);
					}
					else {
						reg->P &= (unsigned char)~(FLAG_C | FLAG_N);
					}
					if (temp_reg1 == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					reg->A = temp_reg1;

					clk_adj_6502(2);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x2f:
			switch (cpukind) {
				/* RLA	 nn' (Absolute) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					temp_reg1 = cpu_pin->t_data.data.data_bus = (unsigned char)(mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] << 1);
					if (reg->P & FLAG_C) {
						temp_reg1 |= 0x01;
					}
					else {
						temp_reg1 &= (unsigned char)~0x01;
					}
					if (mem[cpu_pin->t_addr.addr.addr_bus] & 0x80) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}

					/* Zʊi[ */
					reg->A |= mem[cpu_pin->t_addr.addr.addr_bus] = cpu_pin->t_data.data.data_bus = temp_reg1;

					/* tOEIy[V */
					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					*cpuflag |= MEMOUT;

					clk_adj_6502(5);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x32:
			switch (cpukind) {
				/* HLT */
				case MOS6502:
					halt = CPU_HALT;

					clk_adj_6502(2);
					break;
				/* KIL */
				case RP2A03:
					clk_adj_6502(1);
					break;
				/* AND	imm ((Zero Page)) */
				case W65C02:
				case HuC6280:
					ex_addressing  = mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]];
					ex_addressing |= ((mem[++(cpu_pin->t_addr.addr.addr_bus)] << 0x08) & 0xff00);
					temp_reg1 = reg->A & mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing];

					if ((char)temp_reg1 < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_reg1 == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					reg->A = temp_reg1;

					clk_adj_6502(5);
					break;
				default:
					break;
			}
			break;
		case 0x33:
			switch (cpukind) {
				/* RLA	 (imm), Y (Indirect Index) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned char)mem[++sysreg->PC.pc.pc];
					temp_reg1 = (unsigned char)(mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[ex_addressing] + reg->Y)] << 1);
					if (reg->P & FLAG_C) {
						temp_reg1 |= 0x01;
					}
					else {
						temp_reg1 &= (unsigned char)~0x01;
					}
					if (mem[cpu_pin->t_addr.addr.addr_bus] & 0x80) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}

					/* Zʊi[ */
					reg->A |= mem[cpu_pin->t_addr.addr.addr_bus] = cpu_pin->t_data.data.data_bus = temp_reg1;

					/* tOEIy[V */
					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					*cpuflag |= MEMOUT;

					clk_adj_6502(8);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x34:
			switch (cpukind) {
				/* SKB */
				case MOS6502:
				case RP2A03:
					sysreg->PC.pc.pc++;
					*cpuflag |= PCUPDT;
					clk_adj_6502(4);
					break;
				/* BIT	imm, X (Zero Page, X) */
				case W65C02:
				case HuC6280:
					temp_reg = reg->A & mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X)];
					if (temp_reg & 0x80) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_reg & 0x40) {
						reg->P |= FLAG_V;
					}
					else {
						reg->P &= (unsigned char)~FLAG_V;
					}
					if (temp_reg == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					clk_adj_6502(4);
					break;
				default:
					break;
			}
			break;
		case 0x37:
			switch (cpukind) {
				/* RLA	 imm, X (Zero Page, X) */
				case MOS6502:
				case RP2A03:
					temp_reg1 = (unsigned char)(mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X)] << 1);
					if (reg->P & FLAG_C) {
						temp_reg1 |= 0x01;
					}
					else {
						temp_reg1 &= (unsigned char)~0x01;
					}
					if (mem[cpu_pin->t_addr.addr.addr_bus] & 0x80) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}

					/* Zʊi[ */
					reg->A |= mem[cpu_pin->t_addr.addr.addr_bus] = cpu_pin->t_data.data.data_bus = temp_reg1;

					/* tOEIy[V */
					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					*cpuflag |= MEMOUT;

					clk_adj_6502(6);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x3a:
			switch (cpukind) {
				/* NOP */
				case MOS6502:
				case RP2A03:
					clk_adj_6502(2);
					break;
				/* DEA */
				case W65C02:
				case HuC6280:
					reg->A -= 1;

					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					clk_adj_6502(2);
					break;
				default:
					break;
			}
			break;
		case 0x3b:
			switch (cpukind) {
				/* RLA	 nn', Y (Absolute, Y) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					ex_addressing += reg->Y;
					temp_reg1 = (unsigned char)(mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] << 1);
					if (reg->P & FLAG_C) {
						temp_reg1 |= 0x01;
					}
					else {
						temp_reg1 &= (unsigned char)~0x01;
					}
					if (mem[cpu_pin->t_addr.addr.addr_bus] & 0x80) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}

					/* Zʊi[ */
					reg->A |= mem[cpu_pin->t_addr.addr.addr_bus] = cpu_pin->t_data.data.data_bus = temp_reg1;

					/* tOEIy[V */
					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					*cpuflag |= MEMOUT;

					clk_adj_6502(7);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x3c:
			switch (cpukind) {
				/* SKW */
				case MOS6502:
				case RP2A03:
					sysreg->PC.pc.pc += 2;
					*cpuflag |= PCUPDT;
					clk_adj_6502(4);
					break;
				/* BIT	nn', X (Absolute, X) */
				case W65C02:
				case HuC6280:
					ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					ex_addressing += reg->X;

					temp_reg = reg->A & mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing];
					if (temp_reg & 0x80) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_reg & 0x40) {
						reg->P |= FLAG_V;
					}
					else {
						reg->P &= (unsigned char)~FLAG_V;
					}
					if (temp_reg == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					clk_adj_6502(4);
					break;
				default:
					break;
			}
			break;
		case 0x3f:
			switch (cpukind) {
				/* RLA	 nn', X (Absolute, X) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					ex_addressing += reg->X;
					temp_reg1 = (unsigned char)(mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] << 1);
					if (reg->P & FLAG_C) {
						temp_reg1 |= 0x01;
					}
					else {
						temp_reg1 &= (unsigned char)~0x01;
					}
					if (mem[cpu_pin->t_addr.addr.addr_bus] & 0x80) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}

					/* Zʊi[ */
					reg->A |= mem[cpu_pin->t_addr.addr.addr_bus] = cpu_pin->t_data.data.data_bus = temp_reg1;

					/* tOEIy[V */
					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					*cpuflag |= MEMOUT;

					clk_adj_6502(7);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x42:
			switch (cpukind) {
				/* HLT */
				case MOS6502:
					halt = CPU_HALT;

					clk_adj_6502(2);
					break;
				/* KIL */
				case RP2A03:
					clk_adj_6502(1);
					break;
				/* SAY */
				case HuC6280:
					temp_reg1 = reg->A;
					reg->A = reg->Y;
					reg->Y = temp_reg1;

					reg->P &= (unsigned char)~FLAG_T;

					clk_adj_6502(3);
					break;
				case W65C02:
				default:
					break;
			}
			break;
		case 0x43:
			switch (cpukind) {
				/* LSE	(imm, X) (Index Indirect) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X);
					temp_reg1 = ((mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] >> 1) & (unsigned char)~0x80);
					if (mem[ex_addressing] & 0x01) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}

					/* Zʊi[ */
					cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus] = temp_reg1;
					reg->A ^= cpu_pin->t_data.data.data_bus;

					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					*cpuflag |= MEMOUT;

					clk_adj_6502(8);
					break;
				/* TMA	#imm */
				case HuC6280:
					temp_reg = mem[++sysreg->PC.pc.pc];
					if (temp_reg & 0x80) {
						reg->A = mpr[7];
					}
					else if (temp_reg & 0x40) {
						reg->A = mpr[6];
					}
					else if (temp_reg & 0x20) {
						reg->A = mpr[5];
					}
					else if (temp_reg & 0x10) {
						reg->A = mpr[4];
					}
					else if (temp_reg & 0x08) {
						reg->A = mpr[3];
					}
					else if (temp_reg & 0x04) {
						reg->A = mpr[2];
					}
					else if (temp_reg & 0x02) {
						reg->A = mpr[1];
					}
					else if (temp_reg & 0x01) {
						reg->A = mpr[0];
					}

					reg->P &= (unsigned char)~FLAG_T;

					clk_adj_6502(4);
					break;
				case W65C02:
				default:
					break;
			}
			break;
		case 0x44:
			switch (cpukind) {
				/* SKB */
				case MOS6502:
				case RP2A03:
					sysreg->PC.pc.pc++;
					*cpuflag |= PCUPDT;
					clk_adj_6502(4);
					break;
				/* BSR */
				case HuC6280:
					sysreg->PC.pc.pc += (char)mem[++sysreg->PC.pc.pc];

					reg->P &= (unsigned char)~FLAG_T;

					*cpuflag |= PCUPDT;

					clk_adj_6502(8);
					break;
				case W65C02:
				default:
					break;
			}
			break;
		case 0x47:
			switch (cpukind) {
				/* LSE	imm (Zero Page) */
				case MOS6502:
				case RP2A03:
					temp_reg1 = ((mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]] >> 1) & (unsigned char)~0x80);
					if (mem[cpu_pin->t_addr.addr.addr_bus] & 0x01) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}

					/* Zʊi[ */
					cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus] = temp_reg1;
					reg->A ^= cpu_pin->t_data.data.data_bus;

					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					*cpuflag |= MEMOUT;

					clk_adj_6502(5);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x4b:
			switch (cpukind) {
				/* ALR	#imm */
				case MOS6502:
				case RP2A03:
					temp_reg1 = reg->A & mem[cpu_pin->t_addr.addr.addr_bus = ++sysreg->PC.pc.pc];
					reg->A = ((temp_reg1 >> 1) & (unsigned char)~0x80);
					if (temp_reg1 & 0x01) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					clk_adj_6502(2);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x4f:
			switch (cpukind) {
				/* LSE	nn' (Absolute) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					temp_reg1 = ((mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] >> 1) & (unsigned char)~0x80);
					if (mem[ex_addressing] & 0x01) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}

					/* Zʊi[ */
					cpu_pin->t_data.data.data_bus = mem[ex_addressing] = temp_reg1;
					reg->A ^= cpu_pin->t_data.data.data_bus;

					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					*cpuflag |= MEMOUT;

					clk_adj_6502(6);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x52:
			switch (cpukind) {
				/* HLT */
				case MOS6502:
					halt = CPU_HALT;

					clk_adj_6502(2);
					break;
				/* KIL */
				case RP2A03:
					clk_adj_6502(1);
					break;
				/* EOR	imm ((Zero Page)) */
				case W65C02:
				case HuC6280:
					ex_addressing  = mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]];
					ex_addressing |= ((mem[++(cpu_pin->t_addr.addr.addr_bus)] << 0x08) & 0xff00);
					temp_reg1 = reg->A ^ mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing];

					if ((char)temp_reg1 < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_reg1 == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					/* Zʊi[ */
					reg->A = (unsigned char)temp_reg1;

					clk_adj_6502(5);
					break;
				default:
					break;
			}
			break;
		case 0x53:
			switch (cpukind) {
				/* LSE	(imm), Y (Indirect Index) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned char)mem[++sysreg->PC.pc.pc];
					temp_reg1 = ((mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[ex_addressing] + reg->Y)] >> 1) & (unsigned char)~0x80);
					if (mem[cpu_pin->t_addr.addr.addr_bus] & 0x01) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}

					/* Zʊi[ */
					cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus] = temp_reg1;
					reg->A ^= cpu_pin->t_data.data.data_bus;

					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					*cpuflag |= MEMOUT;

					clk_adj_6502(8);
					break;
				/* TAM	#imm */
				case HuC6280:
					temp_reg = mem[++sysreg->PC.pc.pc];
					if (temp_reg & 0x80) {
						mpr[7] = reg->A;
					}
					else if (temp_reg & 0x40) {
						mpr[6] = reg->A;
					}
					else if (temp_reg & 0x20) {
						mpr[5] = reg->A;
					}
					else if (temp_reg & 0x10) {
						mpr[4] = reg->A;
					}
					else if (temp_reg & 0x08) {
						mpr[3] = reg->A;
					}
					else if (temp_reg & 0x04) {
						mpr[2] = reg->A;
					}
					else if (temp_reg & 0x02) {
						mpr[1] = reg->A;
					}
					else if (temp_reg & 0x01) {
						mpr[0] = reg->A;
					}

					reg->P &= (unsigned char)~FLAG_T;

					clk_adj_6502(5);
					break;
				case W65C02:
				default:
					break;
			}
			break;
		case 0x54:
			switch (cpukind) {
				/* SKB */
				case MOS6502:
				case RP2A03:
					sysreg->PC.pc.pc++;
					*cpuflag |= PCUPDT;
					clk_adj_6502(4);
					break;
				/* CSL */
				case HuC6280:
					Emulate_CPU_Freq = 1.789772;

					reg->P &= (unsigned char)~FLAG_T;

					clk_adj_6502(3);
					break;
				case W65C02:
				default:
					break;
			}
			break;
		case 0x57:
			switch (cpukind) {
				/* LSE	imm, X (Zero Page, X) */
				case MOS6502:
				case RP2A03:
					temp_reg1 = ((mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X)] >> 1) & (unsigned char)~0x80);
					if (mem[cpu_pin->t_addr.addr.addr_bus] & 0x01) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}

					/* Zʊi[ */
					cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus] = temp_reg1;
					reg->A ^= cpu_pin->t_data.data.data_bus;

					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					*cpuflag |= MEMOUT;

					clk_adj_6502(6);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x5a:
			switch (cpukind) {
				/* NOP */
				case MOS6502:
				case RP2A03:
					clk_adj_6502(2);
					break;
				/* PHY */
				case W65C02:
				case HuC6280:
					mem[--sysreg->S + 0x0100] = reg->Y;

					clk_adj_6502(3);
					break;
				default:
					break;
			}
			break;
		case 0x5b:
			switch (cpukind) {
				/* LSE	nn', Y (Absolute, Y) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					ex_addressing += reg->Y;
					temp_reg1 = ((mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] >> 1) & (unsigned char)~0x80);
					if (mem[ex_addressing] & 0x01) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}

					/* Zʊi[ */
					cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus] = temp_reg1;
					reg->A ^= cpu_pin->t_data.data.data_bus;

					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					*cpuflag |= MEMOUT;

					clk_adj_6502(6);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x5c:
			switch (cpukind) {
				/* SKW */
				case MOS6502:
				case RP2A03:
					sysreg->PC.pc.pc += 2;
					*cpuflag |= PCUPDT;
					clk_adj_6502(4);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x5f:
			switch (cpukind) {
				/* LSE	nn', X (Absolute, X) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					ex_addressing += reg->X;
					temp_reg1 = ((mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] >> 1) & (unsigned char)~0x80);
					if (mem[ex_addressing] & 0x01) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}

					/* Zʊi[ */
					cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus] = temp_reg1;
					reg->A ^= cpu_pin->t_data.data.data_bus;

					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					*cpuflag |= MEMOUT;

					clk_adj_6502(6);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x62:
			switch (cpukind) {
				/* HLT */
				case MOS6502:
					halt = CPU_HALT;

					clk_adj_6502(2);
					break;
				/* KIL */
				case RP2A03:
					clk_adj_6502(1);
					break;
				/* CLA */
				case HuC6280:
					reg->A = 0;
					reg->P &= (unsigned char)~FLAG_T;

					clk_adj_6502(2);
					break;
				case W65C02:
				default:
					break;
			}
			break;
		case 0x63:
			switch (cpukind) {
				/* RRA	(imm, X) (Index Indirect) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X);
					temp_reg1 = (unsigned char)(mem[cpu_pin->t_addr.addr.addr_bus = mem[ex_addressing]] >> 1);
					if (reg->P & FLAG_C) {
						temp_reg1 |= 0x80;
					}
					else {
						temp_reg1 &= (unsigned char)~0x80;
					}
					temp_reg = (unsigned short)(reg->A) + (unsigned short)temp_reg1 + (unsigned short)(reg->P & FLAG_C);

					/* tOEIy[V */
					if (temp_reg > 0x00ff) {
						reg->P |= (FLAG_C);
					}
					else {
						reg->P &= ~FLAG_C;
					}
					temp_acr = (char)(temp_reg & 0x00ff);
					if (temp_acr < 0x00) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_acr == 0x00) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}
					if (((temp_acr & 0x80) ^ (reg->A & 0x80)) && (!((reg->A & 0x80) == 0x10))) {
						reg->P |= FLAG_V;
					}
					else if ((!((temp_acr & 0x80) ^ (reg->A & 0x80))) && ((reg->A & 0x80) == 0x80)) {
						reg->P |= FLAG_V;
					}
					else {
						reg->P &= (unsigned char)~FLAG_V;
					}

					/* Zʊi[ */
					reg->A = (unsigned char)temp_acr;
					mem[cpu_pin->t_addr.addr.addr_bus] = cpu_pin->t_data.data.data_bus = temp_reg1;
					*cpuflag |= MEMOUT;

					clk_adj_6502(8);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x64:
			switch (cpukind) {
				/* SKB */
				case MOS6502:
				case RP2A03:
					sysreg->PC.pc.pc++;
					*cpuflag |= PCUPDT;
					clk_adj_6502(4);
					break;
				/* STZ	imm (Zero Page) */
				case W65C02:
				case HuC6280:
					mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]] = 0;

					*cpuflag |= MEMOUT;

					clk_adj_6502(3);
					break;
				default:
					break;
			}
			break;
		case 0x67:
			switch (cpukind) {
				/* RRA	imm (Zero Page) */
				case MOS6502:
				case RP2A03:
					temp_reg1 = (unsigned char)(mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]] >> 1);
					if (reg->P & FLAG_C) {
						temp_reg1 |= 0x80;
					}
					else {
						temp_reg1 &= (unsigned char)~0x80;
					}
					temp_reg = (unsigned short)(reg->A) + (unsigned short)temp_reg1 + (unsigned short)(reg->P & FLAG_C);

					/* tOEIy[V */
					if (temp_reg > 0x00ff) {
						reg->P |= (FLAG_C);
					}
					else {
						reg->P &= ~FLAG_C;
					}
					temp_acr = (char)(temp_reg & 0x00ff);
					if (temp_acr < 0x00) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_acr == 0x00) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}
					if (((temp_acr & 0x80) ^ (reg->A & 0x80)) && (!((reg->A & 0x80) == 0x10))) {
						reg->P |= FLAG_V;
					}
					else if ((!((temp_acr & 0x80) ^ (reg->A & 0x80))) && ((reg->A & 0x80) == 0x80)) {
						reg->P |= FLAG_V;
					}
					else {
						reg->P &= (unsigned char)~FLAG_V;
					}

					/* Zʊi[ */
					reg->A = (unsigned char)temp_acr;
					mem[cpu_pin->t_addr.addr.addr_bus] = cpu_pin->t_data.data.data_bus = temp_reg1;
					*cpuflag |= MEMOUT;

					clk_adj_6502(5);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x6b:
			switch (cpukind) {
				/* ARR	#imm */
				case MOS6502:
				case RP2A03:
					temp_reg1 = reg->A & mem[cpu_pin->t_addr.addr.addr_bus = ++sysreg->PC.pc.pc];
					temp_reg1 = (unsigned char)(temp_reg1 >> 1);
					if (reg->P & FLAG_C) {
						temp_reg1 |= 0x80;
					}
					else {
						temp_reg1 &= (unsigned char)~0x80;
					}
					if (reg->A & 0x01) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}
					if ((char)temp_reg1 < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_reg1 == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					/* Zʊi[ */
					reg->A = temp_reg1;

					clk_adj_6502(2);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x6f:
			switch (cpukind) {
				/* RRA	nn' (Absolute) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					temp_reg1 = (unsigned char)(mem[cpu_pin->t_addr.addr.addr_bus = mem[ex_addressing]] >> 1);
					if (reg->P & FLAG_C) {
						temp_reg1 |= 0x80;
					}
					else {
						temp_reg1 &= (unsigned char)~0x80;
					}
					temp_reg = (unsigned short)(reg->A) + (unsigned short)temp_reg1 + (unsigned short)(reg->P & FLAG_C);

					/* tOEIy[V */
					if (temp_reg > 0x00ff) {
						reg->P |= (FLAG_C);
					}
					else {
						reg->P &= ~FLAG_C;
					}
					temp_acr = (char)(temp_reg & 0x00ff);
					if (temp_acr < 0x00) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_acr == 0x00) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}
					if (((temp_acr & 0x80) ^ (reg->A & 0x80)) && (!((reg->A & 0x80) == 0x10))) {
						reg->P |= FLAG_V;
					}
					else if ((!((temp_acr & 0x80) ^ (reg->A & 0x80))) && ((reg->A & 0x80) == 0x80)) {
						reg->P |= FLAG_V;
					}
					else {
						reg->P &= (unsigned char)~FLAG_V;
					}

					/* Zʊi[ */
					reg->A = (unsigned char)temp_acr;
					mem[cpu_pin->t_addr.addr.addr_bus] = cpu_pin->t_data.data.data_bus = temp_reg1;
					*cpuflag |= MEMOUT;

					clk_adj_6502(6);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x72:
			switch (cpukind) {
				/* HLT */
				case MOS6502:
					halt = CPU_HALT;

					clk_adj_6502(2);
					break;
				/* KIL */
				case RP2A03:
					clk_adj_6502(1);
					break;
				/* ADC	imm ((Zero Page)) */
				case W65C02:
				case HuC6280:
					ex_addressing  = mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]];
					ex_addressing |= ((mem[++(cpu_pin->t_addr.addr.addr_bus)] << 0x08) & 0xff00);
					temp_reg = (unsigned short)(reg->A) + (unsigned short)mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] + (unsigned short)(reg->P & FLAG_C);

					/* tOEIy[V */
					if (temp_reg > 0x00ff) {
						reg->P |= (FLAG_C);
					}
					else {
						reg->P &= ~FLAG_C;
					}
					temp_acr = (char)(temp_reg & 0x00ff);
					if (temp_acr < 0x00) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_acr == 0x00) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}
					if (((temp_acr & 0x80) ^ (reg->A & 0x80)) && (!((reg->A & 0x80) == 0x10))) {
						reg->P |= FLAG_V;
					}
					else if ((!((temp_acr & 0x80) ^ (reg->A & 0x80))) && ((reg->A & 0x80) == 0x80)) {
						reg->P |= FLAG_V;
					}
					else {
						reg->P &= (unsigned char)~FLAG_V;
					}

					/* Zʊi[ */
					reg->A = (unsigned char)temp_acr;

					clk_adj_6502(5);
					break;
				default:
					break;
			}
			break;
		case 0x73:
			switch (cpukind) {
				/* RRA	(imm), Y (Indirect Index) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned char)mem[++sysreg->PC.pc.pc];
					temp_reg1 = (unsigned char)(mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[ex_addressing] + reg->Y)] >> 1);
					if (reg->P & FLAG_C) {
						temp_reg1 |= 0x80;
					}
					else {
						temp_reg1 &= (unsigned char)~0x80;
					}
					temp_reg = (unsigned short)(reg->A) + (unsigned short)temp_reg1 + (unsigned short)(reg->P & FLAG_C);

					/* tOEIy[V */
					if (temp_reg > 0x00ff) {
						reg->P |= (FLAG_C);
					}
					else {
						reg->P &= ~FLAG_C;
					}
					temp_acr = (char)(temp_reg & 0x00ff);
					if (temp_acr < 0x00) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_acr == 0x00) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}
					if (((temp_acr & 0x80) ^ (reg->A & 0x80)) && (!((reg->A & 0x80) == 0x10))) {
						reg->P |= FLAG_V;
					}
					else if ((!((temp_acr & 0x80) ^ (reg->A & 0x80))) && ((reg->A & 0x80) == 0x80)) {
						reg->P |= FLAG_V;
					}
					else {
						reg->P &= (unsigned char)~FLAG_V;
					}

					/* Zʊi[ */
					reg->A = (unsigned char)temp_acr;
					mem[cpu_pin->t_addr.addr.addr_bus] = cpu_pin->t_data.data.data_bus = temp_reg1;
					*cpuflag |= MEMOUT;

					clk_adj_6502(8);
					break;
				/* TII	SHSL, DHDL, LHLL */
				case HuC6280:
					src = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					dst = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					len = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					if (len == 0) {
						len = 65536;
					}
					do {
						callback_bt_6502(dst, src, mem[src]);
						mem[dst++] = mem[src++];
					} while (len--);

					reg->P &= (unsigned char)~FLAG_T;

					*cpuflag |= MEMOUT;

					clk_adj_6502(23);
					break;
				case W65C02:
				default:
					break;
			}
			break;
		case 0x74:
			switch (cpukind) {
				/* SKB */
				case MOS6502:
				case RP2A03:
					sysreg->PC.pc.pc++;
					*cpuflag |= PCUPDT;
					clk_adj_6502(4);
					break;
				/* STZ	imm, X (Zero Page, X) */
				case W65C02:
				case HuC6280:
					mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X)] = 0;

					*cpuflag |= MEMOUT;

					clk_adj_6502(4);
					break;
				default:
					break;
			}
			break;
		case 0x77:
			switch (cpukind) {
				/* RRA	imm, X (Zero Page, X) */
				case MOS6502:
				case RP2A03:
					temp_reg1 = (unsigned char)(mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X)] >> 1);
					if (reg->P & FLAG_C) {
						temp_reg1 |= 0x80;
					}
					else {
						temp_reg1 &= (unsigned char)~0x80;
					}
					temp_reg = (unsigned short)(reg->A) + (unsigned short)temp_reg1 + (unsigned short)(reg->P & FLAG_C);

					/* tOEIy[V */
					if (temp_reg > 0x00ff) {
						reg->P |= (FLAG_C);
					}
					else {
						reg->P &= ~FLAG_C;
					}
					temp_acr = (char)(temp_reg & 0x00ff);
					if (temp_acr < 0x00) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_acr == 0x00) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}
					if (((temp_acr & 0x80) ^ (reg->A & 0x80)) && (!((reg->A & 0x80) == 0x10))) {
						reg->P |= FLAG_V;
					}
					else if ((!((temp_acr & 0x80) ^ (reg->A & 0x80))) && ((reg->A & 0x80) == 0x80)) {
						reg->P |= FLAG_V;
					}
					else {
						reg->P &= (unsigned char)~FLAG_V;
					}

					/* Zʊi[ */
					reg->A = (unsigned char)temp_acr;
					mem[cpu_pin->t_addr.addr.addr_bus] = cpu_pin->t_data.data.data_bus = temp_reg1;
					*cpuflag |= MEMOUT;

					clk_adj_6502(6);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x7a:
			switch (cpukind) {
				/* NOP */
				case MOS6502:
				case RP2A03:
					clk_adj_6502(2);
					break;
				/* PLY */
				case W65C02:
				case HuC6280:
					reg->Y = mem[(sysreg->S++) + 0x0100];

					if ((char)reg->Y < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->Y == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					clk_adj_6502(4);
					break;
				default:
					break;
			}
			break;
		case 0x7b:
			switch (cpukind) {
				/* RRA	nn', Y (Absolute, Y) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					ex_addressing += reg->Y;
					temp_reg1 = (unsigned char)(mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] >> 1);
					if (reg->P & FLAG_C) {
						temp_reg1 |= 0x80;
					}
					else {
						temp_reg1 &= (unsigned char)~0x80;
					}
					temp_reg = (unsigned short)(reg->A) + (unsigned short)temp_reg1 + (unsigned short)(reg->P & FLAG_C);

					/* tOEIy[V */
					if (temp_reg > 0x00ff) {
						reg->P |= (FLAG_C);
					}
					else {
						reg->P &= ~FLAG_C;
					}
					temp_acr = (char)(temp_reg & 0x00ff);
					if (temp_acr < 0x00) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_acr == 0x00) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}
					if (((temp_acr & 0x80) ^ (reg->A & 0x80)) && (!((reg->A & 0x80) == 0x10))) {
						reg->P |= FLAG_V;
					}
					else if ((!((temp_acr & 0x80) ^ (reg->A & 0x80))) && ((reg->A & 0x80) == 0x80)) {
						reg->P |= FLAG_V;
					}
					else {
						reg->P &= (unsigned char)~FLAG_V;
					}

					/* Zʊi[ */
					reg->A = (unsigned char)temp_acr;
					mem[cpu_pin->t_addr.addr.addr_bus] = cpu_pin->t_data.data.data_bus = temp_reg1;
					*cpuflag |= MEMOUT;

					clk_adj_6502(7);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x7c:
			switch (cpukind) {
				/* SKW */
				case MOS6502:
				case RP2A03:
					sysreg->PC.pc.pc += 2;
					*cpuflag |= PCUPDT;
					clk_adj_6502(4);
					break;
				/* JMP nn', X (Absolute, X) */
				case W65C02:
				case HuC6280:
					temp_reg1 = mem[++sysreg->PC.pc.pc];
					temp_reg2 = mem[++sysreg->PC.pc.pc];
					sysreg->PC.pc.t_pc.PCL = temp_reg1;
					sysreg->PC.pc.t_pc.PCH = temp_reg2;
					sysreg->PC.pc.pc += reg->X;
					*cpuflag |= PCUPDT;

					clk_adj_6502(6);
					break;
				default:
					break;
			}
			break;
		case 0x7f:
			switch (cpukind) {
				/* RRA	nn', X (Absolute, X) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					ex_addressing += reg->X;
					temp_reg1 = (unsigned char)(mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] >> 1);
					if (reg->P & FLAG_C) {
						temp_reg1 |= 0x80;
					}
					else {
						temp_reg1 &= (unsigned char)~0x80;
					}
					temp_reg = (unsigned short)(reg->A) + (unsigned short)temp_reg1 + (unsigned short)(reg->P & FLAG_C);

					/* tOEIy[V */
					if (temp_reg > 0x00ff) {
						reg->P |= (FLAG_C);
					}
					else {
						reg->P &= ~FLAG_C;
					}
					temp_acr = (char)(temp_reg & 0x00ff);
					if (temp_acr < 0x00) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_acr == 0x00) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}
					if (((temp_acr & 0x80) ^ (reg->A & 0x80)) && (!((reg->A & 0x80) == 0x10))) {
						reg->P |= FLAG_V;
					}
					else if ((!((temp_acr & 0x80) ^ (reg->A & 0x80))) && ((reg->A & 0x80) == 0x80)) {
						reg->P |= FLAG_V;
					}
					else {
						reg->P &= (unsigned char)~FLAG_V;
					}

					/* Zʊi[ */
					reg->A = (unsigned char)temp_acr;
					mem[cpu_pin->t_addr.addr.addr_bus] = cpu_pin->t_data.data.data_bus = temp_reg1;
					*cpuflag |= MEMOUT;

					clk_adj_6502(7);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x80:
			switch (cpukind) {
				/* SKB */
				case MOS6502:
				case RP2A03:
					sysreg->PC.pc.pc++;
					*cpuflag |= PCUPDT;
					clk_adj_6502(4);
					break;
				/* BRA */
				case W65C02:
				case HuC6280:
					sysreg->PC.pc.pc += (char)mem[++sysreg->PC.pc.pc];

					*cpuflag |= PCUPDT;

					clk_adj_6502(3);
					break;
				default:
					break;
			}
			break;
		case 0x82:
			switch (cpukind) {
				/* SKB */
				case MOS6502:
				case RP2A03:
					sysreg->PC.pc.pc++;
					*cpuflag |= PCUPDT;
					clk_adj_6502(4);
					break;
				/* CLX */
				case HuC6280:
					reg->X = 0;
					reg->P &= (unsigned char)~FLAG_T;

					clk_adj_6502(2);
					break;
				case W65C02:
				default:
					break;
			}
			break;
		case 0x83:
			switch (cpukind) {
				/* AXS	(imm, X) (Index Indirect) */
				case MOS6502:
				case RP2A03:
					temp_reg1 = reg->A & reg->X;

					ex_addressing = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X);
					mem[cpu_pin->t_addr.addr.addr_bus = mem[ex_addressing]] = cpu_pin->t_data.data.data_bus = temp_reg1;

					clk_adj_6502(6);
					break;
				/* TST	#imm (Zero Page) */
				case HuC6280:
					temp_reg1 =  mem[++sysreg->PC.pc.pc];
					temp_reg1 &= mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]];

					if (mem[cpu_pin->t_addr.addr.addr_bus] & 0x80) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (mem[cpu_pin->t_addr.addr.addr_bus] & 0x40) {
						reg->P |= FLAG_V;
					}
					else {
						reg->P &= (unsigned char)~FLAG_V;
					}
					if (temp_reg1 == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}
					reg->P &= (unsigned char)~FLAG_T;

					clk_adj_6502(7);
					break;
				case W65C02:
				default:
					break;
			}
			break;
		case 0x87:
			switch (cpukind) {
				/* AXS	imm (Zero Page) */
				case MOS6502:
				case RP2A03:
					temp_reg1 = reg->A & reg->X;

					mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]] = cpu_pin->t_data.data.data_bus = temp_reg1;

					clk_adj_6502(3);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x89:
			switch (cpukind) {
				/* SKB */
				case MOS6502:
				case RP2A03:
					sysreg->PC.pc.pc++;
					*cpuflag |= PCUPDT;
					clk_adj_6502(2);
					break;
				/* BIT	#imm */
				case W65C02:
				case HuC6280:
					temp_reg = reg->A & mem[cpu_pin->t_addr.addr.addr_bus = ++sysreg->PC.pc.pc];
					if (temp_reg == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					clk_adj_6502(2);
					break;
				default:
					break;
			}
			break;
		case 0x8b:
			switch (cpukind) {
				/* XAA	#imm */
				case MOS6502:
				case RP2A03:
					reg->A = reg->X;
					temp_reg1 = reg->A & mem[cpu_pin->t_addr.addr.addr_bus = ++sysreg->PC.pc.pc];

					if ((char)temp_reg1 < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_reg1 == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					reg->A = temp_reg1;

					clk_adj_6502(2);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x8f:
			switch (cpukind) {
				/* AXS	nn' (Absolute) */
				case MOS6502:
				case RP2A03:
					temp_reg1 = reg->A & reg->X;

					ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] = cpu_pin->t_data.data.data_bus = temp_reg1;

					clk_adj_6502(4);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x92:
			switch (cpukind) {
				/* HLT */
				case MOS6502:
					halt = CPU_HALT;

					clk_adj_6502(2);
					break;
				/* KIL */
				case RP2A03:
					clk_adj_6502(1);
					break;
				/* STA	 */
				case W65C02:
				case HuC6280:
					ex_addressing  = mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]];
					ex_addressing |= ((mem[++(cpu_pin->t_addr.addr.addr_bus)] << 0x08) & 0xff00);
					mem[cpu_pin->t_addr.addr.addr_bus =ex_addressing] = reg->A;
					*cpuflag |= MEMOUT;

					clk_adj_6502(5);
					break;
				default:
					break;
			}
			break;
		case 0x93:
			switch (cpukind) {
				/* AXA	(imm), Y (Indirect Index) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned char)mem[++sysreg->PC.pc.pc];

					mem[0x02] = reg->X;
					temp_reg1  = reg->A & reg->X;
					temp_reg1 &= (ex_addressing + 1);

					mem[cpu_pin->t_addr.addr.addr_bus = (mem[ex_addressing] + reg->Y)] = cpu_pin->t_data.data.data_bus = temp_reg1;

					clk_adj_6502(6);
					break;
				/* TST	nn' (Absolute) */
				case HuC6280:
					temp_reg1 =  mem[++sysreg->PC.pc.pc];
					ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					temp_reg1 &= mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing];

					if (mem[cpu_pin->t_addr.addr.addr_bus] & 0x80) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (mem[cpu_pin->t_addr.addr.addr_bus] & 0x40) {
						reg->P |= FLAG_V;
					}
					else {
						reg->P &= (unsigned char)~FLAG_V;
					}
					if (temp_reg1 == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}
					reg->P &= (unsigned char)~FLAG_T;

					clk_adj_6502(8);
					break;
				case W65C02:
				default:
					break;
			}
			break;
		case 0x97:
			switch (cpukind) {
				/* AXS	nn', Y (Absolute, Y) */
				case MOS6502:
				case RP2A03:
					temp_reg1 = reg->A & reg->X;

					ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					ex_addressing += reg->Y;
					mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] = cpu_pin->t_data.data.data_bus = temp_reg1;

					clk_adj_6502(4);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x9b:
			switch (cpukind) {
				/* TAS */
				case MOS6502:
				case RP2A03:
					temp_reg1 = reg->A & reg->X;

					ex_addressing = (unsigned char)mem[++sysreg->PC.pc.pc];

					mem[0x02] = reg->X;
					mem[--sysreg->S + 0x0100] = temp_reg1;
					temp_reg1 &= (ex_addressing + 1);

					ex_addressing |= (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00);
					ex_addressing += reg->Y;
					mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] = cpu_pin->t_data.data.data_bus = temp_reg1;

					clk_adj_6502(5);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0x9c:
			switch (cpukind) {
				/* SAY */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned char)mem[++sysreg->PC.pc.pc];

					temp_reg1 = reg->Y & (ex_addressing + 1);

					ex_addressing |= (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00);
					ex_addressing += reg->X;
					mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] = cpu_pin->t_data.data.data_bus = temp_reg1;

					clk_adj_6502(5);
					break;
				/* STZ	nn' (Absolute) */
				case W65C02:
				case HuC6280:
					ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] = 0;

					*cpuflag |= MEMOUT;

					clk_adj_6502(4);
					break;
				default:
					break;
			}
			break;
		case 0x9e:
			switch (cpukind) {
				/* XAS */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned char)mem[++sysreg->PC.pc.pc];

					temp_reg1 = reg->X & (ex_addressing + 1);

					ex_addressing |= (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00);
					ex_addressing += reg->Y;
					mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] = cpu_pin->t_data.data.data_bus = temp_reg1;

					clk_adj_6502(5);
					break;
				/* STZ	nn', X (Absolute, X) */
				case W65C02:
				case HuC6280:
					ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					ex_addressing += reg->X;
					mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] = 0;

					*cpuflag |= MEMOUT;

					clk_adj_6502(5);
					break;
				default:
					break;
			}
			break;
		case 0x9f:
			switch (cpukind) {
				/* AXA	nn' (Absolute) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned char)mem[++sysreg->PC.pc.pc];

					mem[0x02] = reg->X;
					temp_reg1  = reg->A & reg->X;
					temp_reg1 &= (ex_addressing + 1);

					ex_addressing |= (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00);
					mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] = cpu_pin->t_data.data.data_bus = temp_reg1;

					clk_adj_6502(5);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0xa3:
			switch (cpukind) {
				/* LAX	(imm, X) (Index Indirect) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X);
					reg->A = reg->X = cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = mem[ex_addressing]];
					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					clk_adj_6502(6);
					break;
				/* TST	#imm, X (Zero Page, X) */
				case HuC6280:
					temp_reg1 =  mem[++sysreg->PC.pc.pc];
					temp_reg1 &= mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X)];

					if (mem[cpu_pin->t_addr.addr.addr_bus] & 0x80) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (mem[cpu_pin->t_addr.addr.addr_bus] & 0x40) {
						reg->P |= FLAG_V;
					}
					else {
						reg->P &= (unsigned char)~FLAG_V;
					}
					if (temp_reg1 == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}
					reg->P &= (unsigned char)~FLAG_T;

					clk_adj_6502(7);
					break;
				case W65C02:
				default:
					break;
			}
			break;
		case 0xa7:
			switch (cpukind) {
				/* LAX	imm (Zero Page) */
				case MOS6502:
				case RP2A03:
					reg->A = reg->X = cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]];
					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					clk_adj_6502(3);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0xab:
			switch (cpukind) {
				/* OAL	#imm */
				case MOS6502:
				case RP2A03:
					reg->A |= 0xee;
					reg->A &= mem[++sysreg->PC.pc.pc];
					reg->X = reg->A;
					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					clk_adj_6502(2);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0xaf:
			switch (cpukind) {
				/* LAX	nn' (Absolute) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					reg->A = reg->X = cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = mem[ex_addressing]];
					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					clk_adj_6502(4);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0xb2:
			switch (cpukind) {
				/* HLT */
				case MOS6502:
					halt = CPU_HALT;

					clk_adj_6502(2);
					break;
				/* KIL */
				case RP2A03:
					clk_adj_6502(1);
					break;
				case W65C02:
				case HuC6280:
					ex_addressing  = mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]];
					ex_addressing |= ((mem[++(cpu_pin->t_addr.addr.addr_bus)] << 0x08) & 0xff00);
					reg->A = cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing];
					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					clk_adj_6502(5);
					break;
				default:
					break;
			}
			break;
		case 0xb3:
			switch (cpukind) {
				/* LAX	(imm), Y (Indirect Index) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned char)mem[++sysreg->PC.pc.pc];
					reg->A = reg->X = cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[ex_addressing] + reg->Y)];
					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					clk_adj_6502(5);
					break;
				/* TST	nn', X (Absolute, X) */
				case HuC6280:
					temp_reg1 =  mem[++sysreg->PC.pc.pc];
					ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					ex_addressing += reg->X;
					temp_reg1 &= mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing];

					if (mem[cpu_pin->t_addr.addr.addr_bus] & 0x80) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (mem[cpu_pin->t_addr.addr.addr_bus] & 0x40) {
						reg->P |= FLAG_V;
					}
					else {
						reg->P &= (unsigned char)~FLAG_V;
					}
					if (temp_reg1 == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}
					reg->P &= (unsigned char)~FLAG_T;

					clk_adj_6502(8);
					break;
				case W65C02:
				default:
					break;
			}
			break;
		case 0xb7:
			switch (cpukind) {
				/* LAX	imm, Y (Zero Page, Y) */
				case MOS6502:
				case RP2A03:
					reg->A = reg->X = cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->Y)];
					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					clk_adj_6502(4);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0xbb:
			switch (cpukind) {
				/* LAS	nn', Y (Absolute, Y) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					ex_addressing += reg->Y;
					temp_reg1 = mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] & sysreg->S;
					reg->A = reg->X = cpu_pin->t_data.data.data_bus = mem[--sysreg->S + 0x0100] = temp_reg1;
					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					clk_adj_6502(4);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0xbf:
			switch (cpukind) {
				/* LAX	nn', Y (Absolute, Y) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					ex_addressing += reg->Y;
					reg->A = reg->X = cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing];
					if ((char)reg->A < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->A == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					clk_adj_6502(4);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0xc2:
			switch (cpukind) {
				/* SKB */
				case MOS6502:
				case RP2A03:
					sysreg->PC.pc.pc++;
					*cpuflag |= PCUPDT;
					clk_adj_6502(4);
					break;
				/* CLY */
				case HuC6280:
					reg->Y = 0;
					reg->P &= (unsigned char)~FLAG_T;

					clk_adj_6502(2);
					break;
				case W65C02:
				default:
					break;
			}
			break;
		case 0xc3:
			switch (cpukind) {
				/* DCM	(imm, X) (Index Indirect) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X);
					temp_reg1 = mem[cpu_pin->t_addr.addr.addr_bus = mem[ex_addressing]] - (char)0x01;
					temp_acr = (char)reg->A - (char)temp_reg1;

					/* tOEIy[V */
					if ((char)(cpu_pin->t_data.data.data_bus) > (char)(reg->A)) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}
					if (temp_acr < 0x00) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_acr == 0x00) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					/* Zʊi[ */
					cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus] = (unsigned char)temp_reg1;
					*cpuflag |= MEMOUT;

					clk_adj_6502(8);
					break;
				/* TDD	SHSL, DHDL, LHLL */
				case HuC6280:
					src = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					dst = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					len = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					if (len == 0) {
						len = 65536;
					}
					do {
						callback_bt_6502(dst, src, mem[src]);
						mem[dst--] = mem[src--];
					} while (len--);

					reg->P &= (unsigned char)~FLAG_T;

					*cpuflag |= MEMOUT;

					clk_adj_6502(23);
					break;
				case W65C02:
				default:
					break;
			}
			break;
		case 0xc7:
			switch (cpukind) {
				/* DCM	imm (Zero Page) */
				case MOS6502:
				case RP2A03:
					temp_reg1 = mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]] - (char)0x01;
					temp_acr = (char)reg->A - (char)temp_reg1;

					/* tOEIy[V */
					if ((char)(cpu_pin->t_data.data.data_bus) > (char)(reg->A)) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}
					if (temp_acr < 0x00) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_acr == 0x00) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					/* Zʊi[ */
					cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus] = (unsigned char)temp_reg1;
					*cpuflag |= MEMOUT;

					clk_adj_6502(5);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0xcb:
			switch (cpukind) {
				/* SKB */
				case MOS6502:
				case RP2A03:
					mem[0x02] = reg->A;
					reg->X &= reg->A;
					temp_reg = (unsigned short)reg->X - (unsigned short)mem[++sysreg->PC.pc.pc] - 1;

					if ((short)temp_reg < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_reg == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}
					if (temp_reg > 0xff) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}

					/* Zʊi[ */
					reg->X = (unsigned char)temp_reg;

					clk_adj_6502(2);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0xcf:
			switch (cpukind) {
				/* DCM	nn' (Absolute) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					temp_reg1 = mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] - (char)0x01;
					temp_acr = (char)reg->A - (char)temp_reg1;

					/* tOEIy[V */
					if ((char)(cpu_pin->t_data.data.data_bus) > (char)(reg->A)) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}
					if (temp_acr < 0x00) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_acr == 0x00) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					/* Zʊi[ */
					cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus] = (unsigned char)temp_reg1;
					*cpuflag |= MEMOUT;

					clk_adj_6502(6);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0xd2:
			switch (cpukind) {
				/* HLT */
				case MOS6502:
					halt = CPU_HALT;

					clk_adj_6502(2);
					break;
				/* KIL */
				case RP2A03:
					clk_adj_6502(1);
					break;
				/* CMP	imm ((Zero Page)) */
				case W65C02:
				case HuC6280:
					ex_addressing  = mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]];
					ex_addressing |= ((mem[++(cpu_pin->t_addr.addr.addr_bus)] << 0x08) & 0xff00);
					temp_acr = (char)reg->A - (char)(cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing]);

					/* tOEIy[V */
					if ((char)(cpu_pin->t_data.data.data_bus) > (char)(reg->A)) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}
					if (temp_acr < 0x00) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_acr == 0x00) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					clk_adj_6502(5);
					break;
				default:
					break;
			}
			break;
		case 0xd3:
			switch (cpukind) {
				/* DCM	(imm), Y (Indirect Index) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned char)mem[++sysreg->PC.pc.pc];
					temp_reg1 = mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[ex_addressing] + reg->Y)] - (char)0x01;
					temp_acr = (char)reg->A - (char)temp_reg1;

					/* tOEIy[V */
					if ((char)(cpu_pin->t_data.data.data_bus) > (char)(reg->A)) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}
					if (temp_acr < 0x00) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_acr == 0x00) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					/* Zʊi[ */
					cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus] = (unsigned char)temp_reg1;
					*cpuflag |= MEMOUT;

					clk_adj_6502(8);
					break;
				/* TIN	SHSL, DHDL, LHLL */
				case HuC6280:
					src = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					dst = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					len = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					if (len == 0) {
						len = 65536;
					}
					do {
						callback_bt_6502(dst, src, mem[src]);
						mem[dst] = mem[src++];
					} while (len--);

					reg->P &= (unsigned char)~FLAG_T;

					*cpuflag |= MEMOUT;

					clk_adj_6502(23);
					break;
				case W65C02:
				default:
					break;
			}
			break;
		case 0xd4:
			switch (cpukind) {
				/* SKB */
				case MOS6502:
				case RP2A03:
					sysreg->PC.pc.pc++;
					*cpuflag |= PCUPDT;
					clk_adj_6502(4);
					break;
				/* CSH */
				case HuC6280:
					Emulate_CPU_Freq = 7.159090;

					reg->P &= (unsigned char)~FLAG_T;

					clk_adj_6502(3);
					break;
				case W65C02:
				default:
					break;
			}
			break;
		case 0xd7:
			switch (cpukind) {
				/* DCM	imm, X (Zero Page, X) */
				case MOS6502:
				case RP2A03:
					temp_reg1 = mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X)] - (char)0x01;
					temp_acr = (char)reg->A - (char)temp_reg1;

					/* tOEIy[V */
					if ((char)(cpu_pin->t_data.data.data_bus) > (char)(reg->A)) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}
					if (temp_acr < 0x00) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_acr == 0x00) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					/* Zʊi[ */
					cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus] = (unsigned char)temp_reg1;
					*cpuflag |= MEMOUT;

					clk_adj_6502(6);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0xda:
			switch (cpukind) {
				/* NOP */
				case MOS6502:
				case RP2A03:
					clk_adj_6502(2);
					break;
				/* PHX */
				case W65C02:
				case HuC6280:
					mem[--sysreg->S + 0x0100] = reg->X;

					clk_adj_6502(3);
					break;
				default:
					break;
			}
			break;
		case 0xdb:
			switch (cpukind) {
				/* DCM	nn', Y (Absolute, Y) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					ex_addressing += reg->Y;
					temp_reg1 = mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] - (char)0x01;
					temp_acr = (char)reg->A - (char)temp_reg1;

					/* tOEIy[V */
					if ((char)(cpu_pin->t_data.data.data_bus) > (char)(reg->A)) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}
					if (temp_acr < 0x00) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_acr == 0x00) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					/* Zʊi[ */
					cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus] = (unsigned char)temp_reg1;
					*cpuflag |= MEMOUT;

					clk_adj_6502(7);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0xdc:
			switch (cpukind) {
				/* SKW */
				case MOS6502:
				case RP2A03:
					sysreg->PC.pc.pc += 2;
					*cpuflag |= PCUPDT;
					clk_adj_6502(4);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0xdf:
			switch (cpukind) {
				/* DCM	nn', X (Absolute, X) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					ex_addressing += reg->X;
					temp_reg1 = mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] - (char)0x01;
					temp_acr = (char)reg->A - (char)temp_reg1;

					/* tOEIy[V */
					if ((char)(cpu_pin->t_data.data.data_bus) > (char)(reg->A)) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}
					if (temp_acr < 0x00) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_acr == 0x00) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					/* Zʊi[ */
					cpu_pin->t_data.data.data_bus = mem[cpu_pin->t_addr.addr.addr_bus] = (unsigned char)temp_reg1;
					*cpuflag |= MEMOUT;

					clk_adj_6502(7);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0xe2:
			switch (cpukind) {
				/* SKB */
				case MOS6502:
				case RP2A03:
					sysreg->PC.pc.pc++;
					*cpuflag |= PCUPDT;
					clk_adj_6502(4);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0xe3:
			switch (cpukind) {
				/* INS	(imm, X) (Index Indirect) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X);
					temp_acr = (char)mem[cpu_pin->t_addr.addr.addr_bus = mem[ex_addressing]] + (char)0x01;
					temp_reg = (unsigned short)reg->A - (unsigned short)temp_acr - (unsigned short)(reg->P & FLAG_C);

					if ((short)temp_reg < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_reg == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}
					if (temp_reg > 0xff) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}
					if (temp_reg & 0x40) {
						reg->P |= FLAG_V;
					}
					else {
						reg->P &= (unsigned char)~FLAG_V;
					}

					/* Zʊi[ */
					mem[cpu_pin->t_addr.addr.addr_bus] = (unsigned char)temp_acr;
					reg->A = (unsigned char)temp_reg;

					*cpuflag |= MEMOUT;
					clk_adj_6502(8);
					break;
				/* TIA	SHSL, DHDL, LHLL */
				case HuC6280:
					src = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					dst = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					len = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					if (len == 0) {
						len = 65536;
					}
					cnt = 0;
					do {
						callback_bt_6502(dst, src, mem[src]);
						mem[dst] = mem[src++];
						if (cnt ^= 0x01) {
							dst += 1;
						}
						else {
							dst -= 1;
						}
					} while (len--);

					reg->P &= (unsigned char)~FLAG_T;

					*cpuflag |= MEMOUT;

					clk_adj_6502(23);
					break;
				case W65C02:
				default:
					break;
			}
			break;
		case 0xe7:
			switch (cpukind) {
				/* INS	imm (Zero Page) */
				case MOS6502:
				case RP2A03:
					temp_acr = (char)mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]] + (char)0x01;
					temp_reg = (unsigned short)reg->A - (unsigned short)temp_acr - (unsigned short)(reg->P & FLAG_C);

					if ((short)temp_reg < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_reg == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}
					if (temp_reg > 0xff) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}
					if (temp_reg & 0x40) {
						reg->P |= FLAG_V;
					}
					else {
						reg->P &= (unsigned char)~FLAG_V;
					}

					/* Zʊi[ */
					mem[cpu_pin->t_addr.addr.addr_bus] = (unsigned char)temp_acr;
					reg->A = (unsigned char)temp_reg;

					*cpuflag |= MEMOUT;
					clk_adj_6502(5);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0xeb:
			switch (cpukind) {
				/* SBC	#imm */
				case MOS6502:
				case RP2A03:
					temp_reg = (unsigned short)reg->A - (unsigned short)mem[++sysreg->PC.pc.pc] - (unsigned short)(reg->P & FLAG_C);
					if ((short)temp_reg < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_reg == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}
					if (temp_reg > 0xff) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}
					if (temp_reg & 0x40) {
						reg->P |= FLAG_V;
					}
					else {
						reg->P &= (unsigned char)~FLAG_V;
					}

					/* Zʊi[ */
					reg->A = (unsigned char)temp_reg;

					clk_adj_6502(2);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0xef:
			switch (cpukind) {
				/* INS	nn' (Absolute) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					temp_acr = (char)mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] + (char)0x01;
					temp_reg = (unsigned short)reg->A - (unsigned short)temp_acr - (unsigned short)(reg->P & FLAG_C);

					if ((short)temp_reg < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_reg == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}
					if (temp_reg > 0xff) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}
					if (temp_reg & 0x40) {
						reg->P |= FLAG_V;
					}
					else {
						reg->P &= (unsigned char)~FLAG_V;
					}

					/* Zʊi[ */
					mem[cpu_pin->t_addr.addr.addr_bus] = (unsigned char)temp_acr;
					reg->A = (unsigned char)temp_reg;

					*cpuflag |= MEMOUT;
					clk_adj_6502(6);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0xf2:
			switch (cpukind) {
				/* HLT */
				case MOS6502:
					halt = CPU_HALT;

					clk_adj_6502(2);
					break;
				/* KIL */
				case RP2A03:
					clk_adj_6502(1);
					break;
				/* SBC	imm ((Zero Page)) */
				case W65C02:
				case HuC6280:
					ex_addressing  = mem[cpu_pin->t_addr.addr.addr_bus = mem[++sysreg->PC.pc.pc]];
					ex_addressing |= ((mem[++(cpu_pin->t_addr.addr.addr_bus)] << 0x08) & 0xff00);
					temp_reg = (unsigned short)reg->A - (unsigned short)mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] - (unsigned short)(reg->P & FLAG_C);
					if ((short)temp_reg < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_reg == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}
					if (temp_reg > 0xff) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}
					if (temp_reg & 0x40) {
						reg->P |= FLAG_V;
					}
					else {
						reg->P &= (unsigned char)~FLAG_V;
					}

					/* Zʊi[ */
					reg->A = (unsigned char)temp_reg;

					clk_adj_6502(5);
					break;
				default:
					break;
			}
			break;
		case 0xf3:
			switch (cpukind) {
				/* INS	(imm), Y (Indirect Index) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned char)mem[++sysreg->PC.pc.pc];
					temp_acr = (char)mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[ex_addressing] + reg->Y)] + (char)0x01;
					temp_reg = (unsigned short)reg->A - (unsigned short)temp_acr - (unsigned short)(reg->P & FLAG_C);

					if ((short)temp_reg < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_reg == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}
					if (temp_reg > 0xff) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}
					if (temp_reg & 0x40) {
						reg->P |= FLAG_V;
					}
					else {
						reg->P &= (unsigned char)~FLAG_V;
					}

					/* Zʊi[ */
					mem[cpu_pin->t_addr.addr.addr_bus] = (unsigned char)temp_acr;
					reg->A = (unsigned char)temp_reg;

					*cpuflag |= MEMOUT;
					clk_adj_6502(8);
					break;
				/* TAI	SHSL, DHDL, LHLL */
				case HuC6280:
					src = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					dst = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					len = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					if (len == 0) {
						len = 65536;
					}
					cnt = 0;
					do {
						callback_bt_6502(dst, src, mem[src]);
						mem[dst++] = mem[src];
						if (cnt ^= 0x01) {
							src += 1;
						}
						else {
							src -= 1;
						}
					} while (len--);

					reg->P &= (unsigned char)~FLAG_T;

					*cpuflag |= MEMOUT;

					clk_adj_6502(23);
					break;
				case W65C02:
				default:
					break;
			}
			break;
		case 0xf4:
			switch (cpukind) {
				/* SKB */
				case MOS6502:
				case RP2A03:
					mem[0x02] = reg->A;
					reg->X &= reg->A;
					temp_reg = (unsigned short)reg->X - (unsigned short)mem[++sysreg->PC.pc.pc] - 1;

					if ((short)temp_reg < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_reg == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}
					if (temp_reg > 0xff) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}

					/* Zʊi[ */
					reg->X = (unsigned char)temp_reg;

					clk_adj_6502(2);
					break;
				/* SET */
				case HuC6280:
					reg->P |= FLAG_T;

					clk_adj_6502(2);
					break;
				case W65C02:
				default:
					break;
			}
			break;
		case 0xf7:
			switch (cpukind) {
				/* INS	imm, X (Zero Page, X) */
				case MOS6502:
				case RP2A03:
					temp_acr = (char)mem[cpu_pin->t_addr.addr.addr_bus = (unsigned char)(mem[++sysreg->PC.pc.pc] + reg->X)] + (char)0x01;
					temp_reg = (unsigned short)reg->A - (unsigned short)temp_acr - (unsigned short)(reg->P & FLAG_C);

					if ((short)temp_reg < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_reg == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}
					if (temp_reg > 0xff) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}
					if (temp_reg & 0x40) {
						reg->P |= FLAG_V;
					}
					else {
						reg->P &= (unsigned char)~FLAG_V;
					}

					/* Zʊi[ */
					mem[cpu_pin->t_addr.addr.addr_bus] = (unsigned char)temp_acr;
					reg->A = (unsigned char)temp_reg;

					*cpuflag |= MEMOUT;
					clk_adj_6502(6);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0xfa:
			switch (cpukind) {
				/* NOP */
				case MOS6502:
				case RP2A03:
					clk_adj_6502(2);
					break;
				/* PLX */
				case W65C02:
				case HuC6280:
					reg->X = mem[(sysreg->S++) + 0x0100];

					if ((char)reg->X < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (reg->X == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}

					clk_adj_6502(4);
					break;
				default:
					break;
			}
			break;
		case 0xfb:
			switch (cpukind) {
				/* INS	nn', Y (Absolute, Y) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					ex_addressing += reg->Y;
					temp_acr = (char)mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] + (char)0x01;
					temp_reg = (unsigned short)reg->A - (unsigned short)temp_acr - (unsigned short)(reg->P & FLAG_C);

					if ((short)temp_reg < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_reg == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}
					if (temp_reg > 0xff) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}
					if (temp_reg & 0x40) {
						reg->P |= FLAG_V;
					}
					else {
						reg->P &= (unsigned char)~FLAG_V;
					}

					/* Zʊi[ */
					mem[cpu_pin->t_addr.addr.addr_bus] = (unsigned char)temp_acr;
					reg->A = (unsigned char)temp_reg;

					*cpuflag |= MEMOUT;
					clk_adj_6502(7);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0xfc:
			switch (cpukind) {
				/* SKW */
				case MOS6502:
				case RP2A03:
					sysreg->PC.pc.pc += 2;
					*cpuflag |= PCUPDT;
					clk_adj_6502(4);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		case 0xff:
			switch (cpukind) {
				/* INS	nn', X (Absolute, X) */
				case MOS6502:
				case RP2A03:
					ex_addressing = (unsigned short)(mem[++sysreg->PC.pc.pc] | (((unsigned short)mem[++sysreg->PC.pc.pc] << 0x08) & 0xff00));
					ex_addressing += reg->X;
					temp_acr = (char)mem[cpu_pin->t_addr.addr.addr_bus = ex_addressing] + (char)0x01;
					temp_reg = (unsigned short)reg->A - (unsigned short)temp_acr - (unsigned short)(reg->P & FLAG_C);

					if ((short)temp_reg < 0) {
						reg->P |= FLAG_N;
					}
					else {
						reg->P &= (unsigned char)~FLAG_N;
					}
					if (temp_reg == 0) {
						reg->P |= FLAG_Z;
					}
					else {
						reg->P &= (unsigned char)~FLAG_Z;
					}
					if (temp_reg > 0xff) {
						reg->P |= FLAG_C;
					}
					else {
						reg->P &= (unsigned char)~FLAG_C;
					}
					if (temp_reg & 0x40) {
						reg->P |= FLAG_V;
					}
					else {
						reg->P &= (unsigned char)~FLAG_V;
					}

					/* Zʊi[ */
					mem[cpu_pin->t_addr.addr.addr_bus] = (unsigned char)temp_acr;
					reg->A = (unsigned char)temp_reg;

					*cpuflag |= MEMOUT;
					clk_adj_6502(7);
					break;
				case W65C02:
				case HuC6280:
				default:
					break;
			}
			break;
		default:
			break;
	}


	if (!(cpu_pin->t_ctl.ctl.t_ctl.IRQ) && !(reg->P & FLAG_I)) {
		mem[--sysreg->S + 0x0100] = sysreg->PC.pc.t_pc.PCH;
		mem[--sysreg->S + 0x0100] = sysreg->PC.pc.t_pc.PCL;
		mem[--sysreg->S + 0x0100] = (reg->P & (unsigned char)~FLAG_Brk);
		reg->P |= FLAG_I;
		sysreg->PC.pc.t_pc.PCL = mem[0xfffe];
		sysreg->PC.pc.t_pc.PCH = mem[0xffff];
		*cpuflag |= (PCUPDT | MEMOUT);
	}

	return (int)halt;
}
